/* GTK Napster-0.301
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#ifndef _NAPSTER_H_
#define _NAPSTER_H_

#include <sys/time.h>
#include <stdio.h>
#include <gtk/gtk.h>

#define TITLEBAR_MAIN 						"GTK Napster-0.301"
//#define NAPSTER_DEBUG
//#define LOCAL_TEST

#define RECV_SELECT_TIMOUT -3
#define RECV_SELECT_ERROR -4
#define RECV_SELECT_CANCEL -5

#define CLIST_SEARCH_FINISHED 				"Finished searching entire database!"
#define CLIST_SEARCH_SEARCHING 				"Searching, please wait..."
#define HL_CLIST_START						"Browsing files..."
#define HL_CLIST_FINISHED  				 	"Finished browsing files!"


#define LINE_SPEED_T3 						"T3 (or greater)"
#define LINE_SPEED_T1 						"T1"
#define LINE_SPEED_DSL 						"DSL"
#define LINE_SPEED_CABLE 					"Cable"
#define LINE_SPEED_ISDN128 					"ISDN-128k"
#define LINE_SPEED_ISDN56 					"ISDN-56k"
#define LINE_SPEED_56MODEM 					"56k Modem"
#define LINE_SPEED_33MODEM 					"33.6 Modem"
#define LINE_SPEED_28MODEM 					"28.8 Modem"
#define LINE_SPEED_14MODEM 					"14.4 Modem"
#define LINE_SPEED_UNKNOWN 					"Unknown"

#define COLUMN_FILENAME 					"Filename"
#define COLUMN_FILESIZE 					"Filesize"
#define COLUMN_PROGRESS 					"Progress"
#define COLUMN_USER 						"User"
#define COLUMN_LINESPEED 					"Line Speed"
#define COLUMN_STATUS 						"Status"
#define COLUMN_SONGS 						"Songs"
#define COLUMN_SPEED 						"Speed"
#define COLUMN_BITRATE 						"Bitrate"
#define COLUMN_FREQ 						"Freq"
#define COLUMN_LENGTH 						"Length"

#define PRIVATE_CHAT_WINDOW 				"Private"

typedef struct gtk_search_window
{
	GtkWidget *search_for_entry;
	GtkWidget *max_results_entry;
	GtkWidget *linespeed_combo;
	GtkWidget *bitrate_combo;
	GtkWidget *freq_combo;
	GtkWidget *linespeed_crit;
	GtkWidget *bitrate_crit;
	GtkWidget *freq_crit;
} gtk_search_window;

typedef struct shared_parm
{
	gchar *md5;
	gdouble size;
	gint time;
} shared_parm;

typedef struct gtk_chat_window
{
	GtkWidget *ctext;
	GtkWidget *cmsg;
	GtkWidget *clist;
	gchar name[20];
} gtk_chat_window;

typedef struct gtk_hotlist_window
{
	GtkWidget *clist;
	GtkWidget *onlinelist;
	GtkWidget *offlinelist;
	GList *selection;
	gchar user[20];
	GdkPixmap *pixm;
	GdkBitmap *bitm;
	guint8 spacing;
} gtk_hotlist_window;

typedef struct gtk_pixmap_sess
{
	GdkBitmap *bm_red;
	GdkPixmap *pm_red;
	GdkBitmap *bm_green;
	GdkPixmap *pm_green;
	GdkBitmap *bm_gold;
	GdkPixmap *pm_gold;
} gtk_pixmap_sess;

typedef struct gtk_resume_parm
{
	GtkWidget *clist;
	GtkWidget *status;
	GtkWidget *dialog;
	gboolean RECEIVING;
	gboolean OPEN;
	glong size;
	gchar md5[50];
} gtk_resume_parm;

typedef struct chat_parm
{
	GtkWidget *clist;
	gint row;
} chat_parm;

typedef struct gtk_sess
{
	GtkWidget *window;
	gchar username[20];
	gchar password[20];
	gchar email[100];
	gchar directory[100];
	gchar sharedir[150];
	gchar exec_player[150];
	gint speed;
	gint timeout;
	gint maxdls;
	gint maxuls;
	gint port;
		
	/*test*/
	gint received;
	gint16 toreceive;
	gint16 code;
	gchar buffer[4096];
	/*test end*/
		
	chat_parm chatparm;
	gboolean CONNECTED;
	gboolean FIREWALL;
	gboolean SHOW_TABS;
	gboolean SHOW_BYTE;
	gboolean SHOW_DHMS;
	gboolean PASSWORD;
	gboolean SWITCH_TRANSFER;
	gboolean AUTO_CONNECT;
	gint sockfd;
	gint sockid;
	gint listenfd;
	gint listenid;
	GtkWidget *statusbar;
	GtkWidget *clist;
	GtkWidget *login_dialog;
	GtkWidget *login_label;
	GtkWidget *page;
	GtkWidget *library_clist;
	GList *current_sel;
	GList *queue;
	GList *transfer_sel;
	GList *ul_sel;
	GList *lib_selection;
	GtkWidget *transfer_list;
	GtkWidget *ul_list;
	GtkWidget *notebook;
	gint nr_chatwins;
	gtk_chat_window *chatwins;
	gtk_search_window search;
	gtk_hotlist_window hotlist;
	gtk_pixmap_sess pixmaps;
	gtk_resume_parm resume;
} gtk_sess;

typedef struct gtk_dl_sess
{
	gtk_sess *sess;
	gchar *filename;
	gchar md5[50];
	gint socketid;
	gint socketfd;
	glong size;
	glong current;
	gint bitrate;
	glong freq;
	time_t start_time;
	FILE *stream;
	gboolean ACTIVE;
	gboolean CONNECTING;
	gboolean CANCEL;
	gboolean CLEAR;
} gtk_dl_sess;

typedef struct gtk_ul_sess
{
	gtk_sess *sess;
	gint socketid;
	gint socketfd;
	glong size;
	glong current;
	FILE *stream;
	gboolean ACTIVE;
	gboolean CONNECTING;
	gboolean CANCEL;
	gboolean CLEAR;
} gtk_ul_sess;

void lib_add(GtkWidget *widget, gpointer data);
void lib_remove_file(gtk_sess *sess, gint row);
void sort_column(GtkCList *clist, gint column, gpointer user_data);

void search_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data);
void hotlist_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data);
void download_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data);
void upload_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data);
void chat_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data);
void uhluser_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data);
void ahluser_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data);
void library_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data);

void get_user_info(gtk_sess *sess);
gchar *make_file(gchar *in);

gchar *make_text_size(glong size);
gchar *make_text_time(glong size, gboolean STYLE);

GtkWidget *make_pixmapwid(GtkWidget *parent, gchar *name[]);

void about_napster(GtkWidget *widget, gpointer data);
gboolean must_be_queued(gtk_sess *sess);

gboolean seperate_string(gchar *instr, gchar **outlist, gint nr);

void add_hl_dialog(GtkWidget *widget, gpointer data);
void add_user_to_hotlist(gtk_sess *sess, gchar *username);

void cancel_download_sess(gtk_dl_sess *dlsess);
void cancel_ul_sess(gtk_ul_sess *ulsess);

void play_file(GtkWidget *widget, gpointer data);
gint connect_with_select(gint socketfd, gpointer dest_addr, time_t timeout, gint timeoutafter, gboolean *CANCEL);
gint recv_with_select(gint socketfd, gchar *buffer, gint sizetoread, time_t timeout, gint timeoutafter, gboolean *CANCEL);

void change_to_transfer(GtkWidget *widget, gpointer data);
void change_to_chat(GtkWidget *widget, gpointer data);
void change_to_search(GtkWidget *widget, gpointer data);
void change_to_library(GtkWidget *widget, gpointer data);
void change_to_hotlist(GtkWidget *widget, gpointer data);

void gtk_message_warning(gchar *message, gchar *title);
void gtk_message_error(gchar *message, gchar *title);
void gtk_message_about(gchar *message, gchar *title);
void gtk_message_whois(gchar *message, gchar *title);
void connect_dialog(GtkWidget *widget, gpointer data);
void disconnect_napster(GtkWidget *widget, gpointer data);
void settings_dialog(GtkWidget *widget, gpointer data);

void selection_changed(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void selection_unselected(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer user_data);
void transfer_selection_changed(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void transfer_selection_unselected(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer user_data);
void library_selection_changed(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void library_selection_unselected(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer user_data);
void upload_selection_changed(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void upload_selection_unselected(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer user_data);

void WriteSharedFile(gtk_sess *sess);
void command_hotlist_nofiles(gtk_sess *sess, gchar *instr);
void command_hotlist_results(gtk_sess *sess, gchar *instr);
void command_hotlist_online(gtk_sess *sess, gchar *instr);
void command_hl_useradd(gtk_sess *sess, gchar *username);
void hl_send_logon_request(GtkWidget *widget, gpointer data);
void remove_hl_dialog(GtkWidget *widget, gpointer data);

void get_file_ok(gtk_sess *sess, gchar *instr);
void dl_incomming(gtk_sess *sess, gint socketfd, time_t start_time);

void get_file_from(gtk_sess *sess, gboolean searchWindow, gint selrow);

void make_share_list(gtk_sess* sess);

GtkWidget *make_hotlist_page(gtk_sess *sess);

void ReadRCFile(gtk_sess *sess);
void WriteRCFile(gtk_sess *sess);

void destroy(GtkWidget *w, gpointer data);
void make_chat_box(gtk_sess *sess, gchar *name, gint list);
gint get_chat_box_nr(gtk_sess *sess, gchar *name);

gchar *get_speed(gint speed);
gint get_speed_nr(gchar *in);

gboolean napster_connect(gtk_sess *sess, gboolean newuser, gboolean *LOCK, gboolean *CANCEL, gchar *ip, gint port);

GtkWidget *make_menu(gtk_sess *sess);

gboolean napster_something_to_read(gpointer data, gint source, GdkInputCondition condition); 
gint send_string(gtk_sess *sess, gchar *instr, gint16 code);

void read_command_run(gtk_sess *sess, gint code, gchar *instr);
void string_out(GtkWidget *widget, gchar *instr, gint red, gint green, gint blue);

void command_do_search(GtkWidget *w, gpointer data);
void read_command(GtkWidget *widget, gpointer data);
void resume_dialog(gtk_dl_sess *dlsess);
void firewall_connection(gtk_sess *sess, gchar *instr);

#endif
