/* GTK Napster-0.301
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _DLSESS_H_
#define _DLSESS_H_

#define STATUSBAR_ERROR_TRANSFER 				"Error: Failed to create transfer socket."
#define STATUSBAR_ERROR_GET 					"Error: Failed to send GET."
#define STATUSBAR_ERROR_OK 						"Error: Failed to recieve OK from server."
#define STATUSBAR_ERROR_FILENAME 				"Error: Failed to send username and filename to server."
#define STATUSBAR_ERROR_FILESIZE 				"Error: Failed to recieve filesize from server."
#define STATUSBAR_ERROR_INVALID_REQUEST 		"Error: Received a INVALID REQUEST from server."
#define STATUSBAR_ERROR_NOT_SHARED 				"Error: The file is NOT SHARED."
#define STATUSBAR_ERROR_NOT_FOUND 				"Error: The file is NOT FOUND."
#define STATUSBAR_ERROR_FILE 					"Error: Creating file for writing."

#define TRANSFER_STATUS_CONNECTING 				"Connecting..."
#define TRANSFER_STATUS_GET 					"Send Info..."
#define TRANSFER_STATUS_OK 						"Get Info..."
#define TRANSFER_STATUS_FILE 					"Send File..."
#define TRANSFER_STATUS_SIZE 					"Get Size..."
#define TRANSFER_STATUS_DOWNLOAD 				"Downloading..."
#define TRANSFER_STATUS_FIREWALL				"Firewall..."
#define TRANSFER_STATUS_ERROR		 			"Error!"
#define TRANSFER_STATUS_CANCEL	 				"Canceled!"
#define TRANSFER_STATUS_FINISH	 				"Finished!"
#define TRANSFER_STATUS_TIMEOUT	 				"Timeout!"
#define TRANSFER_STATUS_WAIT 					"Waiting..."

/* 1=Percent done */
#define TITLEBAR_STATUS									"%d%% Done! (GTK-Napster)"	

gboolean must_be_queued(gtk_sess *sess);
void check_queue(gtk_sess *sess);
gint connect_to_fileserver(gtk_dl_sess *dlsess, gchar *ip, gchar *port, gchar *file, gint row, gchar *filename);
void transfer_selection_changed(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void transfer_selection_unselected(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer user_data);
void library_selection_changed(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void library_selection_unselected(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer user_data);
void upload_selection_changed(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void upload_selection_unselected(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer user_data);
gchar *make_file(gchar *in);
void get_file_ok(gtk_sess *sess, gchar *instr);
void file_to_read(gpointer data, gint source, GdkInputCondition condition);
void cancel_download_sess(gtk_dl_sess *dlsess);
void selection_unselected(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer user_data);
void selection_changed(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void dl_incomming(gtk_sess *sess, gint socketfd, time_t start_time);


#endif