/* GTK Napster-0.301
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <string.h>
#include "common.h"
#include "menu.h"
#include "naction.h"

void search_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data)
{
	gint row, column;
	GtkWidget *search_menu;
	GtkWidget *item_get;
	GtkWidget *item_hotlist;
	GtkWidget *item_unselect;
	gtk_sess *sess = (gtk_sess *)data;
	
	if(event->button != 3) return;
	
	gtk_clist_get_selection_info(GTK_CLIST(sess->clist), event->x , event->y, &row, &column);
	if(g_list_find(sess->current_sel, GINT_TO_POINTER(row)) == NULL) 
	{
		gtk_clist_unselect_all(GTK_CLIST(sess->clist));
		gtk_clist_select_row(GTK_CLIST(sess->clist), row, column);
	}
	
	search_menu = gtk_menu_new();
	
	item_get = gtk_menu_item_new_with_label(MENU_ITEM_GET);
	item_hotlist = gtk_menu_item_new_with_label(MENU_ITEM_HOTLIST);
	item_unselect = gtk_menu_item_new_with_label(MENU_ITEM_UNSELECT);

	if(g_list_length(sess->current_sel) == 0)
	{
		gtk_widget_set_sensitive(GTK_WIDGET(item_get), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(item_hotlist), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(item_unselect), FALSE);
	}

	gtk_signal_connect(GTK_OBJECT(item_get), "activate", GTK_SIGNAL_FUNC(get_file), sess);
	gtk_signal_connect(GTK_OBJECT(item_hotlist), "activate", GTK_SIGNAL_FUNC(add_search_hotlist), sess);	
	gtk_signal_connect(GTK_OBJECT(item_unselect), "activate", GTK_SIGNAL_FUNC(unselect_search), sess);

	gtk_menu_append(GTK_MENU(search_menu), item_get);
	gtk_menu_append(GTK_MENU(search_menu), item_hotlist);
	gtk_menu_append(GTK_MENU(search_menu), item_unselect);

	gtk_widget_show(item_get);
	gtk_widget_show(item_hotlist);
	gtk_widget_show(item_unselect);

	gtk_menu_popup(GTK_MENU(search_menu), NULL, NULL, NULL, NULL, event->button, event->time);
}

void chat_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data)
{
	gint row, column;
	GtkWidget *chat_menu;
	GtkWidget *item_whois;
	GtkWidget *item_hotlist;
	gtk_sess *sess = (gtk_sess *)data;
	
	if(event->button != 3) return;
	
	gtk_clist_get_selection_info(GTK_CLIST(widget), event->x , event->y, &row, &column);
	gtk_clist_select_row(GTK_CLIST(widget), row, column);
	
	chat_menu = gtk_menu_new();
	
	item_whois = gtk_menu_item_new_with_label(MENU_ITEM_WHOIS);
	item_hotlist = gtk_menu_item_new_with_label(MENU_ITEM_HOTLIST);
	
	sess->chatparm.row = row;
	sess->chatparm.clist = widget;
	
	gtk_signal_connect(GTK_OBJECT(item_whois), "activate", GTK_SIGNAL_FUNC(chat_whois), sess);
	gtk_signal_connect(GTK_OBJECT(item_hotlist), "activate", GTK_SIGNAL_FUNC(chat_hotlist), sess);
	
	gtk_menu_append(GTK_MENU(chat_menu), item_whois);
	gtk_menu_append(GTK_MENU(chat_menu), item_hotlist);

	gtk_widget_show(item_whois);
	gtk_widget_show(item_hotlist);

	gtk_menu_popup(GTK_MENU(chat_menu), NULL, NULL, NULL, NULL, event->button, event->time);
}

void library_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data)
{
	gint row, column;
	GtkWidget *lib_menu;
	GtkWidget *item_remove;
	GtkWidget *item_add;
	GtkWidget *item_unselect;
	gtk_sess *sess = (gtk_sess *)data;
	
	if(event->button != 3) return;
	
	gtk_clist_get_selection_info(GTK_CLIST(sess->library_clist), event->x , event->y, &row, &column);
	if(g_list_find(sess->lib_selection, GINT_TO_POINTER(row)) == NULL) 
	{
		gtk_clist_unselect_all(GTK_CLIST(sess->library_clist));
		gtk_clist_select_row(GTK_CLIST(sess->library_clist), row, column);
	}
	
	lib_menu = gtk_menu_new();
	
	item_add = gtk_menu_item_new_with_label(MENU_ITEM_ADD);
	item_remove = gtk_menu_item_new_with_label(MENU_ITEM_REMOVE);
	item_unselect = gtk_menu_item_new_with_label(MENU_ITEM_UNSELECT);

	if(g_list_length(sess->lib_selection) == 0)
		gtk_widget_set_sensitive(GTK_WIDGET(item_remove), FALSE);
	
	gtk_signal_connect(GTK_OBJECT(item_add), "activate", GTK_SIGNAL_FUNC(lib_add), sess);
	gtk_signal_connect(GTK_OBJECT(item_remove), "activate", GTK_SIGNAL_FUNC(lib_remove), sess);
	gtk_signal_connect(GTK_OBJECT(item_unselect), "activate", GTK_SIGNAL_FUNC(unselect_library), sess);
	
	gtk_menu_append(GTK_MENU(lib_menu), item_add);
	gtk_menu_append(GTK_MENU(lib_menu), item_remove);
	gtk_menu_append(GTK_MENU(lib_menu), item_unselect);
	
	gtk_widget_show(item_add);
	gtk_widget_show(item_remove);
	gtk_widget_show(item_unselect);

	gtk_menu_popup(GTK_MENU(lib_menu), NULL, NULL, NULL, NULL, event->button, event->time);
}

void ahluser_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data)
{
	gint row, column;
	GtkWidget *user_menu;
	GtkWidget *item_remove;
	GtkWidget *item_view;
	gtk_sess *sess = (gtk_sess *)data;
	
	if(event->button != 3) return;
	
	gtk_clist_get_selection_info(GTK_CLIST(widget), event->x , event->y, &row, &column);
	gtk_clist_select_row(GTK_CLIST(widget), row, column);
	
	user_menu = gtk_menu_new();
	
	item_view = gtk_menu_item_new_with_label(MENU_ITEM_VIEW);
	item_remove = gtk_menu_item_new_with_label(MENU_ITEM_REMOVE);
	
	sess->chatparm.row = row;
	sess->chatparm.clist = widget;
	
	gtk_signal_connect(GTK_OBJECT(item_view), "activate", GTK_SIGNAL_FUNC(ahluser_view), sess);
	gtk_signal_connect(GTK_OBJECT(item_remove), "activate", GTK_SIGNAL_FUNC(ahluser_remove), sess);
	
	gtk_menu_append(GTK_MENU(user_menu), item_view);
	gtk_menu_append(GTK_MENU(user_menu), item_remove);

	gtk_widget_show(item_view);
	gtk_widget_show(item_remove);

	gtk_menu_popup(GTK_MENU(user_menu), NULL, NULL, NULL, NULL, event->button, event->time);
}

void uhluser_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data)
{
	gint row, column;
	GtkWidget *user_menu;
	GtkWidget *item_remove;
	gtk_sess *sess = (gtk_sess *)data;
	
	if(event->button != 3) return;
	
	gtk_clist_get_selection_info(GTK_CLIST(widget), event->x , event->y, &row, &column);
	gtk_clist_select_row(GTK_CLIST(widget), row, column);
	
	user_menu = gtk_menu_new();
	
	item_remove = gtk_menu_item_new_with_label(MENU_ITEM_REMOVE);
	
	sess->chatparm.row = row;
	sess->chatparm.clist = widget;
	
	gtk_signal_connect(GTK_OBJECT(item_remove), "activate", GTK_SIGNAL_FUNC(uhluser_remove), sess);
	
	gtk_menu_append(GTK_MENU(user_menu), item_remove);

	gtk_widget_show(item_remove);

	gtk_menu_popup(GTK_MENU(user_menu), NULL, NULL, NULL, NULL, event->button, event->time);
}


void hotlist_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data)
{
	gint row, column;
	GtkWidget *hotlist_menu;
	GtkWidget *item_get;
	GtkWidget *item_unselect;
	gtk_sess *sess = (gtk_sess *)data;
	
	if(event->button != 3) return;
	
	gtk_clist_get_selection_info(GTK_CLIST(sess->hotlist.clist), event->x , event->y, &row, &column);
	if(g_list_find(sess->hotlist.selection, GINT_TO_POINTER(row)) == NULL) 
	{
		gtk_clist_unselect_all(GTK_CLIST(sess->hotlist.clist));
		gtk_clist_select_row(GTK_CLIST(sess->hotlist.clist), row, column);
	}
	
	hotlist_menu = gtk_menu_new();
	
	item_get = gtk_menu_item_new_with_label(MENU_ITEM_GET);
	item_unselect = gtk_menu_item_new_with_label(MENU_ITEM_UNSELECT);

	if(g_list_length(sess->hotlist.selection) == 0)
	{
		gtk_widget_set_sensitive(GTK_WIDGET(item_get), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(item_unselect), FALSE);
	}
		
	gtk_signal_connect(GTK_OBJECT(item_get), "activate", GTK_SIGNAL_FUNC(get_file_hl), sess);
	gtk_signal_connect(GTK_OBJECT(item_unselect), "activate", GTK_SIGNAL_FUNC(unselect_hotlist), sess);
		
	gtk_menu_append(GTK_MENU(hotlist_menu), item_get);
	gtk_menu_append(GTK_MENU(hotlist_menu), item_unselect);

	gtk_widget_show(item_get);
	gtk_widget_show(item_unselect);

	gtk_menu_popup(GTK_MENU(hotlist_menu), NULL, NULL, NULL, NULL, event->button, event->time);
}

void download_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data)
{
	gint row, column;
	GtkWidget *dl_menu;
	GtkWidget *item_cancel;
	GtkWidget *item_retry;
	GtkWidget *item_resume;
	GtkWidget *item_clear;
	GtkWidget *item_hotlist;
	GtkWidget *item_play;
	GtkWidget *item_unselect;
	gtk_sess *sess = (gtk_sess *)data;
	gtk_dl_sess *dlsess;
	
	if(event->button != 3) return;
	
	gtk_clist_get_selection_info(GTK_CLIST(sess->transfer_list), event->x , event->y, &row, &column);
	if(g_list_find(sess->transfer_sel, GINT_TO_POINTER(row)) == NULL) 
	{
		gtk_clist_unselect_all(GTK_CLIST(sess->transfer_list));
		gtk_clist_select_row(GTK_CLIST(sess->transfer_list), row, column);
	}
	
	dl_menu = gtk_menu_new();
	
	item_cancel = gtk_menu_item_new_with_label(MENU_ITEM_DLCANCEL);
	item_retry = gtk_menu_item_new_with_label(MENU_ITEM_RETRY);
	item_resume = gtk_menu_item_new_with_label(MENU_ITEM_RESUME);
	item_clear = gtk_menu_item_new_with_label(MENU_ITEM_DLCLEAR);
	item_hotlist = gtk_menu_item_new_with_label(MENU_ITEM_HOTLIST);
	item_play = gtk_menu_item_new_with_label(MENU_ITEM_PLAY);
	item_unselect = gtk_menu_item_new_with_label(MENU_ITEM_UNSELECT);

	if(g_list_length(sess->transfer_sel) == 0)
	{
		gtk_widget_set_sensitive(GTK_WIDGET(item_cancel), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(item_retry), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(item_resume), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(item_clear), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(item_hotlist), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(item_play), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(item_unselect), FALSE);
	}
	else if(g_list_length(sess->transfer_sel) > 1)
	{
		gtk_widget_set_sensitive(GTK_WIDGET(item_resume), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(item_play), FALSE);
	}
	else
	{
		dlsess = gtk_clist_get_row_data(GTK_CLIST(sess->transfer_list), GPOINTER_TO_INT(g_list_nth_data(sess->transfer_sel, 0)));
		if(dlsess->ACTIVE || dlsess->CONNECTING)
		{
			gtk_widget_set_sensitive(GTK_WIDGET(item_retry), FALSE);
			gtk_widget_set_sensitive(GTK_WIDGET(item_resume), FALSE);				
		}
		else
		{
			if((strcasecmp((gchar *)dlsess->md5, "") == 0) || (dlsess->size <= 0))
				gtk_widget_set_sensitive(GTK_WIDGET(item_resume), FALSE);
		}
	}

	gtk_signal_connect(GTK_OBJECT(item_cancel), "activate", GTK_SIGNAL_FUNC(cancel_download), sess);
	gtk_signal_connect(GTK_OBJECT(item_clear), "activate", GTK_SIGNAL_FUNC(clear_transfer), sess);
	gtk_signal_connect(GTK_OBJECT(item_resume), "activate", GTK_SIGNAL_FUNC(resume_download), sess);
	gtk_signal_connect(GTK_OBJECT(item_retry), "activate", GTK_SIGNAL_FUNC(retry_download), sess);
	gtk_signal_connect(GTK_OBJECT(item_hotlist), "activate", GTK_SIGNAL_FUNC(add_download_hotlist), sess);
	gtk_signal_connect(GTK_OBJECT(item_unselect), "activate", GTK_SIGNAL_FUNC(unselect_download), sess);
	gtk_signal_connect(GTK_OBJECT(item_play), "activate", GTK_SIGNAL_FUNC(play_file), sess);

	gtk_menu_append(GTK_MENU(dl_menu), item_cancel);
	gtk_menu_append(GTK_MENU(dl_menu), item_retry);
	gtk_menu_append(GTK_MENU(dl_menu), item_resume);
	gtk_menu_append(GTK_MENU(dl_menu), item_clear);
	gtk_menu_append(GTK_MENU(dl_menu), item_hotlist);
	gtk_menu_append(GTK_MENU(dl_menu), item_play);
	gtk_menu_append(GTK_MENU(dl_menu), item_unselect);

	gtk_widget_show(item_cancel);
	gtk_widget_show(item_retry);
	gtk_widget_show(item_resume);
	gtk_widget_show(item_clear);
	gtk_widget_show(item_hotlist);
	gtk_widget_show(item_play);
	gtk_widget_show(item_unselect);

	gtk_menu_popup(GTK_MENU(dl_menu), NULL, NULL, NULL, NULL, event->button, event->time);
}

void upload_right_clicked(GtkWidget *widget,  GdkEventButton *event, gpointer data)
{
	gint row, column;
	GtkWidget *ul_menu;
	GtkWidget *item_cancel;
	GtkWidget *item_clear;
	GtkWidget *item_hotlist;
	GtkWidget *item_unselect;
	gtk_sess *sess = (gtk_sess *)data;
	
	if(event->button != 3) return;
	
	gtk_clist_get_selection_info(GTK_CLIST(sess->ul_list), event->x , event->y, &row, &column);
	
	if(g_list_find(sess->ul_sel, GINT_TO_POINTER(row)) == NULL) 
	{
		gtk_clist_unselect_all(GTK_CLIST(sess->ul_list));
		gtk_clist_select_row(GTK_CLIST(sess->ul_list), row, column);
	}
	
	ul_menu = gtk_menu_new();
	
	item_cancel = gtk_menu_item_new_with_label(MENU_ITEM_ULCANCEL);
	item_clear = gtk_menu_item_new_with_label(MENU_ITEM_ULCLEAR);
	item_hotlist = gtk_menu_item_new_with_label(MENU_ITEM_HOTLIST);
	item_unselect = gtk_menu_item_new_with_label(MENU_ITEM_UNSELECT);
	
	if(g_list_length(sess->ul_sel) == 0)
	{
		gtk_widget_set_sensitive(GTK_WIDGET(item_cancel), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(item_clear), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(item_hotlist), FALSE);
		gtk_widget_set_sensitive(GTK_WIDGET(item_unselect), FALSE);
	}
	
	gtk_menu_append(GTK_MENU(ul_menu), item_cancel);
	gtk_menu_append(GTK_MENU(ul_menu), item_clear);
	gtk_menu_append(GTK_MENU(ul_menu), item_hotlist);
	gtk_menu_append(GTK_MENU(ul_menu), item_unselect);

	gtk_signal_connect(GTK_OBJECT(item_cancel), "activate", GTK_SIGNAL_FUNC(cancel_upload), sess);
	gtk_signal_connect(GTK_OBJECT(item_clear), "activate", GTK_SIGNAL_FUNC(clear_upload), sess);
	gtk_signal_connect(GTK_OBJECT(item_hotlist), "activate", GTK_SIGNAL_FUNC(add_upload_hotlist), sess);
	gtk_signal_connect(GTK_OBJECT(item_unselect), "activate", GTK_SIGNAL_FUNC(unselect_upload), sess);

	gtk_widget_show(item_cancel);
	gtk_widget_show(item_clear);
	gtk_widget_show(item_hotlist);
	gtk_widget_show(item_unselect);

	gtk_menu_popup(GTK_MENU(ul_menu), NULL, NULL, NULL, NULL, event->button, event->time);
}

GtkWidget *make_menu(gtk_sess *sess)
{
	GtkWidget *menu_bar;

	GtkWidget *file_menu;
	GtkWidget *item_connect;
	GtkWidget *item_disconnect;
	GtkWidget *item_quit;
	GtkWidget *file_item;
	
	GtkWidget *view_menu;
	GtkWidget *search_item;
	GtkWidget *chat_item;
	GtkWidget *hl_item;
	GtkWidget *library_item;
	GtkWidget *transfer_item;
	GtkWidget *view_item;
	
	GtkWidget *edit_menu;
	GtkWidget *settings_item;
	GtkWidget *edit_item;
	
	GtkWidget *hotlist_menu;
	GtkWidget *addhl_item;
	GtkWidget *remove_item;
	GtkWidget *refresh_item;
	GtkWidget *hotlist_item;
	
	GtkWidget *about_item;
	
	file_menu = gtk_menu_new();
	
	item_quit = gtk_menu_item_new_with_label(MENU_ITEM_QUIT);	
	item_connect = gtk_menu_item_new_with_label(MENU_ITEM_CONNECT);
	item_disconnect = gtk_menu_item_new_with_label(MENU_ITEM_DISCONNECT);
	gtk_menu_append(GTK_MENU(file_menu), item_connect);
	gtk_menu_append(GTK_MENU(file_menu), item_disconnect);
	gtk_menu_append(GTK_MENU(file_menu), item_quit);
	
	gtk_signal_connect(GTK_OBJECT(item_connect), "activate", GTK_SIGNAL_FUNC(connect_dialog), sess);
	gtk_signal_connect(GTK_OBJECT(item_disconnect), "activate", GTK_SIGNAL_FUNC(disconnect_napster), sess);
	gtk_signal_connect(GTK_OBJECT(item_quit), "activate", GTK_SIGNAL_FUNC(destroy), sess);
	
	gtk_widget_show(item_connect);
	gtk_widget_show(item_disconnect);
	gtk_widget_show(item_quit);
	
	view_menu = gtk_menu_new();
	
	chat_item = gtk_menu_item_new_with_label(MENU_ITEM_GOTOCHAT);	
	search_item = gtk_menu_item_new_with_label(MENU_ITEM_GOTOSEARCH);
	hl_item = gtk_menu_item_new_with_label(MENU_ITEM_GOTOHOTLIST);
	library_item = gtk_menu_item_new_with_label(MENU_ITEM_GOTOLIBRARY);
	transfer_item = gtk_menu_item_new_with_label(MENU_ITEM_GOTOTRANSFER);
	gtk_menu_append(GTK_MENU(view_menu), chat_item);
	gtk_menu_append(GTK_MENU(view_menu), search_item);
	gtk_menu_append(GTK_MENU(view_menu), hl_item);
	gtk_menu_append(GTK_MENU(view_menu), library_item);
	gtk_menu_append(GTK_MENU(view_menu), transfer_item);

	gtk_signal_connect(GTK_OBJECT(search_item), "activate", GTK_SIGNAL_FUNC(change_to_search), sess);
	gtk_signal_connect(GTK_OBJECT(transfer_item), "activate", GTK_SIGNAL_FUNC(change_to_transfer), sess);
	gtk_signal_connect(GTK_OBJECT(chat_item), "activate", GTK_SIGNAL_FUNC(change_to_chat), sess);
	gtk_signal_connect(GTK_OBJECT(library_item), "activate", GTK_SIGNAL_FUNC(change_to_library), sess);
	gtk_signal_connect(GTK_OBJECT(hl_item), "activate", GTK_SIGNAL_FUNC(change_to_hotlist), sess);
	
	gtk_widget_show(search_item);
	gtk_widget_show(transfer_item);
	gtk_widget_show(hl_item);
	gtk_widget_show(library_item);
	gtk_widget_show(chat_item);
	
	edit_menu = gtk_menu_new();
	settings_item = gtk_menu_item_new_with_label(MENU_ITEM_SETTINGS);	
	gtk_menu_append(GTK_MENU(edit_menu), settings_item);
	gtk_signal_connect(GTK_OBJECT(settings_item), "activate", GTK_SIGNAL_FUNC(settings_dialog), sess);
	gtk_widget_show(settings_item);
	
	hotlist_menu = gtk_menu_new();
	addhl_item = gtk_menu_item_new_with_label(MENU_ITEM_ADDHL);	
	gtk_menu_append(GTK_MENU(hotlist_menu), addhl_item);
	gtk_signal_connect(GTK_OBJECT(addhl_item), "activate", GTK_SIGNAL_FUNC(add_hl_dialog), sess);
	gtk_widget_show(addhl_item);
	
	remove_item = gtk_menu_item_new_with_label(MENU_ITEM_REMOVEHL);	
	gtk_menu_append(GTK_MENU(hotlist_menu), remove_item);
	gtk_signal_connect(GTK_OBJECT(remove_item), "activate", GTK_SIGNAL_FUNC(remove_hl_dialog), sess);
	gtk_widget_show(remove_item);
	
	refresh_item = gtk_menu_item_new_with_label(MENU_ITEM_REFRESH);	
	gtk_menu_append(GTK_MENU(hotlist_menu), refresh_item);
	gtk_signal_connect(GTK_OBJECT(refresh_item), "activate", GTK_SIGNAL_FUNC(hl_send_logon_request), sess);
	gtk_widget_show(refresh_item);
	
	file_item = gtk_menu_item_new_with_label(MENU_FILE);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(file_item), file_menu);
	gtk_widget_show(file_item);
	
	edit_item = gtk_menu_item_new_with_label(MENU_EDIT);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(edit_item), edit_menu);
	gtk_widget_show(edit_item);
	
	view_item = gtk_menu_item_new_with_label(MENU_VIEW);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(view_item), view_menu);
	gtk_widget_show(view_item);
	
	hotlist_item = gtk_menu_item_new_with_label(MENU_HOTLIST);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(hotlist_item), hotlist_menu);
	gtk_widget_show(hotlist_item);
	
	about_item = gtk_menu_item_new_with_label(MENU_ABOUT);
	gtk_signal_connect(GTK_OBJECT(about_item), "activate", GTK_SIGNAL_FUNC(about_napster), sess);
	gtk_widget_show(about_item);
	
	menu_bar = gtk_menu_bar_new();
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), file_item);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), edit_item);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), view_item);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), hotlist_item);
	gtk_menu_bar_append(GTK_MENU_BAR(menu_bar), about_item);
	gtk_menu_item_right_justify(GTK_MENU_ITEM(about_item));
	
	return menu_bar;
}
