/* GTK Napster-0.301
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <string.h>
#include "common.h"
#include "naction.h"

void lib_remove(GtkWidget *w, gpointer data)
{
	gint i;	
	gtk_sess *sess = (gtk_sess *)data;
	
	for(i=0; i<g_list_length(sess->lib_selection); i++)
		lib_remove_file(sess, GPOINTER_TO_INT(g_list_nth_data(sess->lib_selection, i)));
}

void get_file(GtkWidget *w, gpointer data)
{
	gint i;	
	gtk_sess *sess = (gtk_sess *)data;
	for(i=0; i<g_list_length(sess->current_sel); i++)
		get_file_from(sess, TRUE, GPOINTER_TO_INT(g_list_nth_data(sess->current_sel, i)));
}

void get_file_hl(GtkWidget *w, gpointer data)
{
	gint i;	
	gtk_sess *sess = (gtk_sess *)data;
	for(i=0; i<g_list_length(sess->hotlist.selection); i++)
		get_file_from(sess, FALSE, GPOINTER_TO_INT(g_list_nth_data(sess->hotlist.selection, i)));
}

void cancel_download(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_dl_sess *dlsess;
	gint i;	

	for(i=0; i<g_list_length(sess->transfer_sel); i++)
	{
		dlsess = gtk_clist_get_row_data(GTK_CLIST(sess->transfer_list), GPOINTER_TO_INT(g_list_nth_data(sess->transfer_sel, i)));
		cancel_download_sess(dlsess);
		gtk_clist_set_text(GTK_CLIST(sess->transfer_list), GPOINTER_TO_INT(g_list_nth_data(sess->transfer_sel, i)), 5, TRANSFER_STATUS_CANCEL);
	}
}

void clear_transfer(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gint i;	

	for(i=g_list_length(sess->transfer_sel)-1; i>-1; i--)
	{
		gtk_clist_remove(GTK_CLIST(sess->transfer_list), GPOINTER_TO_INT(g_list_nth_data(sess->transfer_sel, i)));
	}
}

void cancel_upload(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_ul_sess *ulsess;
	gint i;	

	for(i=0; i<g_list_length(sess->ul_sel); i++)
	{
		ulsess = gtk_clist_get_row_data(GTK_CLIST(sess->ul_list), GPOINTER_TO_INT(g_list_nth_data(sess->ul_sel, i)));
		cancel_ul_sess(ulsess);
		gtk_clist_set_text(GTK_CLIST(sess->ul_list), GPOINTER_TO_INT(g_list_nth_data(sess->ul_sel, i)), 5, TRANSFER_STATUS_CANCEL);
	}
}

void clear_upload(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gint i;	

	for(i=g_list_length(sess->ul_sel)-1; i>-1; i--)
	{
		gtk_clist_remove(GTK_CLIST(sess->ul_list), GPOINTER_TO_INT(g_list_nth_data(sess->ul_sel, i)));
	}
}

void unselect_download(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_clist_unselect_all(GTK_CLIST(sess->transfer_list));
}

void unselect_search(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_clist_unselect_all(GTK_CLIST(sess->clist));
}

void unselect_hotlist(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_clist_unselect_all(GTK_CLIST(sess->hotlist.clist));
}

void unselect_upload(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_clist_unselect_all(GTK_CLIST(sess->ul_list));
}

void unselect_library(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_clist_unselect_all(GTK_CLIST(sess->library_clist));
}

void resume_download(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_dl_sess *dlsess;
	gchar *command;		
		
	g_print("in rd\n");
	if(sess->resume.RECEIVING) return;
	dlsess = gtk_clist_get_row_data(GTK_CLIST(sess->transfer_list), GPOINTER_TO_INT(g_list_nth_data(sess->transfer_sel, 0)));
 	if(sess->resume.OPEN)
	{
	  	if(dlsess == NULL)
		{ 
			g_warning("Received a null pointer when resuming"); 
			return;
		}
		if((dlsess->CONNECTING) || (dlsess->ACTIVE)) return;
		if(strcasecmp((gchar *)dlsess->md5, "") == 0) return;
		if(dlsess->size <= 0) return;
		
		command = g_malloc(strlen(dlsess->md5) + 15);
		sprintf(command, "%s %.0f", dlsess->md5, (double)dlsess->size);
		g_print("%s\n", command);
		send_string(dlsess->sess, command, 215);
		dlsess->sess->resume.RECEIVING = TRUE;
		g_free(command);
	}
	else resume_dialog(dlsess);
 	g_print("out rd\n");
}

void retry_download(GtkWidget *w, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_dl_sess *dlsess;
	gchar *user;
	gchar *command;
	gint i, dlrow;

	for(i=0; i<g_list_length(sess->transfer_sel); i++)
	{
		dlsess = gtk_clist_get_row_data(GTK_CLIST(sess->transfer_list), GPOINTER_TO_INT(g_list_nth_data(sess->transfer_sel, i)));
		
		dlrow = gtk_clist_find_row_from_data(GTK_CLIST(dlsess->sess->transfer_list), dlsess);
		gtk_clist_get_text(GTK_CLIST(dlsess->sess->transfer_list), dlrow, 3, &user);
		
		if(!must_be_queued(dlsess->sess))
		{
			command = (gchar *)g_malloc(strlen(dlsess->filename) + strlen(user) + 5);
			sprintf(command, "%s \"%s\"", user, dlsess->filename);
	
			if(!send_string(dlsess->sess, command, 203))
			{
				gtk_clist_set_text(GTK_CLIST(dlsess->sess->transfer_list), dlrow, 5, TRANSFER_STATUS_ERROR);
				gtk_statusbar_push(GTK_STATUSBAR(dlsess->sess->statusbar), 1, STATUSBAR_GET_INFO);
			}
			else dlsess->CONNECTING = TRUE;
			g_free(command);
		}
		else
		{
			gtk_clist_set_text(GTK_CLIST(dlsess->sess->transfer_list), dlrow, 5, TRANSFER_STATUS_QUEUED);
			dlsess->sess->queue = g_list_append(dlsess->sess->queue, (gpointer)dlsess);
		}
	}
}

void add_download_hotlist(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gchar *user;
	gint i, row;	

	for(i=0; i<g_list_length(sess->transfer_sel); i++)
	{
		row = GPOINTER_TO_INT(g_list_nth_data(sess->transfer_sel, i));
		gtk_clist_get_text(GTK_CLIST(sess->transfer_list), row, 3, &user);
		add_user_to_hotlist(sess, user);
	}
}

void chat_hotlist(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gchar *user;
	guint8 spacing;
	GdkPixmap *pixm;
	GdkBitmap *bitm;

	gtk_clist_get_pixtext(GTK_CLIST(sess->chatparm.clist), sess->chatparm.row, 0, &user, (guint8 *)&spacing, &pixm, &bitm);
	add_user_to_hotlist(sess, user);
}

void ahluser_remove(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gchar *user;
	guint8 spacing;
	GdkPixmap *pixm;
	GdkBitmap *bitm;

	gtk_clist_get_pixtext(GTK_CLIST(sess->chatparm.clist), sess->chatparm.row, 0, &user, (guint8 *)&spacing, &pixm, &bitm);
		
	if(!send_string(sess, user, 303)) return;
	gtk_clist_remove(GTK_CLIST(sess->hotlist.onlinelist), sess->chatparm.row);
}

void ahluser_view(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gchar *user;
	gchar *inlist[5];
		
	memset(inlist, 0, sizeof(inlist));
	inlist[0] = HL_CLIST_START;	
	
	gtk_clist_get_pixtext(GTK_CLIST(sess->chatparm.clist), sess->chatparm.row, 0, &user, (guint8 *)&sess->hotlist.spacing, &sess->hotlist.pixm, &sess->hotlist.bitm);
	
	strcpy((gchar *)sess->hotlist.user, user);
		
	if(g_list_length(sess->hotlist.selection) > 0) g_list_free(sess->hotlist.selection);
	sess->hotlist.selection = NULL;
	
	gtk_clist_clear(GTK_CLIST(sess->hotlist.clist));
	gtk_clist_append(GTK_CLIST(sess->hotlist.clist), inlist);
	send_string(sess, user, 211);
}

void uhluser_remove(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gchar *user;

	gtk_clist_get_text(GTK_CLIST(sess->chatparm.clist), sess->chatparm.row, 0, &user);
		
	if(!send_string(sess, user, 303)) return;
	gtk_clist_remove(GTK_CLIST(sess->hotlist.offlinelist), sess->chatparm.row);
}

void chat_whois(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gchar *user;
	guint8 spacing;
	GdkPixmap *pixm;
	GdkBitmap *bitm;
	gtk_clist_get_pixtext(GTK_CLIST(sess->chatparm.clist), sess->chatparm.row, 0, &user, (guint8 *)&spacing, &pixm, &bitm);
	send_string(sess, user, 603);
}

void add_upload_hotlist(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gchar *user;
	gint i, row;	

	for(i=0; i<g_list_length(sess->ul_sel); i++)
	{
		row = GPOINTER_TO_INT(g_list_nth_data(sess->ul_sel, i));
		gtk_clist_get_text(GTK_CLIST(sess->ul_list), row, 3, &user);
		add_user_to_hotlist(sess, user);
	}
}

void add_search_hotlist(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_dl_sess *dlsess;
	gchar *user;
	gint i, row;	

	for(i=0; i<g_list_length(sess->current_sel); i++)
	{
		dlsess = gtk_clist_get_row_data(GTK_CLIST(sess->clist), GPOINTER_TO_INT(g_list_nth_data(sess->current_sel, i)));
		row = gtk_clist_find_row_from_data(GTK_CLIST(sess->clist), dlsess);
		gtk_clist_get_text(GTK_CLIST(sess->clist), row, 5, &user);
		add_user_to_hotlist(sess, user);
	}
}