/* GTK Napster-0.301
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#include <string.h>
#include <unistd.h>

#include "common.h"
#include "napster.h"
#include "sort.h"

void disconnect_napster(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *) data;
	gint i;
		
	if(sess->CONNECTED == TRUE) 
	{
		gdk_input_remove(sess->sockid);
		close(sess->sockfd);
	}

	for(i=0; i<sess->nr_chatwins; i++)
	{
		gtk_notebook_remove_page(GTK_NOTEBOOK(sess->notebook), -1);
	}
	
	if(g_list_length(sess->current_sel) > 0) g_list_free(sess->current_sel);
	sess->current_sel = NULL;
	
	if(g_list_length(sess->queue) > 0) g_list_free(sess->queue);
	sess->queue = NULL;

	WriteSharedFile(sess);

	gtk_clist_clear(GTK_CLIST(sess->clist));
	gtk_clist_clear(GTK_CLIST(sess->library_clist));
	gtk_clist_clear(GTK_CLIST(sess->transfer_list));
	gtk_clist_clear(GTK_CLIST(sess->ul_list));
	gtk_clist_clear(GTK_CLIST(sess->hotlist.clist));

	
	if(sess->nr_chatwins != 0)
		g_free(sess->chatwins);

	sess->nr_chatwins = 0;
	sess->CONNECTED = FALSE;	

	gtk_statusbar_push(GTK_STATUSBAR(sess->statusbar), 1, STATUSBAR_WELCOME);
}

void destroy(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *) data;
	
	if(sess->CONNECTED) disconnect_napster(NULL, (gpointer)sess);
	WriteRCFile(sess);
	g_free(sess);
	gtk_main_quit();
}

void change_to_chat(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_notebook_set_page(GTK_NOTEBOOK(sess->page), 0);
}

void change_to_search(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_notebook_set_page(GTK_NOTEBOOK(sess->page), 1);
}

void change_to_hotlist(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_notebook_set_page(GTK_NOTEBOOK(sess->page), 2);
}

void change_to_library(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_notebook_set_page(GTK_NOTEBOOK(sess->page), 3);
}

void change_to_transfer(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gtk_notebook_set_page(GTK_NOTEBOOK(sess->page), 4);
}

void about_napster(GtkWidget *widget, gpointer data)
{
	gtk_message_about(ABOUT, ABOUT_TITLE);	
}

gint get_chat_box_nr(gtk_sess *sess, gchar *name)
{
	gint i;
	for(i=0; i<sess->nr_chatwins; i++)
	{
		if(strcmp(sess->chatwins[i].name, name) == 0)
			return i;
	}
	return -1;
}

GtkWidget *make_search_page(gtk_sess *sess)
{
	GtkWidget *vbox;
	GtkWidget *table;
	GtkWidget *search_for_label;
	GtkWidget *max_results_label;
	GtkWidget *linespeed_label;
	GtkWidget *bitrate_label;
	GtkWidget *freq_label;
	GtkWidget *search_button;
	GtkWidget *frame;
	GtkWidget *scrolled_window;
	gchar *ltitles[7] = {COLUMN_FILENAME,COLUMN_FILESIZE,COLUMN_BITRATE,COLUMN_FREQ, COLUMN_LENGTH, COLUMN_USER, COLUMN_LINESPEED};
	GList *bitrate=NULL;
	GList *linespeed=NULL;
	GList *freq=NULL;
	GList *crit=NULL;
	
	bitrate = g_list_append(bitrate, "");
	bitrate = g_list_append(bitrate, "256 KB/s");
	bitrate = g_list_append(bitrate, "192 KB/s");
	bitrate = g_list_append(bitrate, "160 KB/s");
	bitrate = g_list_append(bitrate, "128 KB/s");
	bitrate = g_list_append(bitrate, "112 KB/s");
	bitrate = g_list_append(bitrate, "98 KB/s");
	bitrate = g_list_append(bitrate, "64 KB/s");
	bitrate = g_list_append(bitrate, "56 KB/s");
	bitrate = g_list_append(bitrate, "48 KB/s");
	bitrate = g_list_append(bitrate, "32 KB/s");
	bitrate = g_list_append(bitrate, "24 KB/s");
	bitrate = g_list_append(bitrate, "20 KB/s");
	
	freq = g_list_append(freq, "");	
	freq = g_list_append(freq, "48000 HZ");
	freq = g_list_append(freq, "44100 HZ");
	freq = g_list_append(freq, "32000 HZ");
	freq = g_list_append(freq, "24000 HZ");
	freq = g_list_append(freq, "22050 HZ");
	freq = g_list_append(freq, "16000 HZ");
	freq = g_list_append(freq, "12000 HZ");
	freq = g_list_append(freq, "11025 HZ");
	freq = g_list_append(freq, "8000 HZ");
	
	linespeed = g_list_append(linespeed, "");
	linespeed = g_list_append(linespeed, LINE_SPEED_T3);
	linespeed = g_list_append(linespeed, LINE_SPEED_T1);
	linespeed = g_list_append(linespeed, LINE_SPEED_DSL);
	linespeed = g_list_append(linespeed, LINE_SPEED_CABLE);
	linespeed = g_list_append(linespeed, LINE_SPEED_ISDN128);
	linespeed = g_list_append(linespeed, LINE_SPEED_ISDN56);
	linespeed = g_list_append(linespeed, LINE_SPEED_56MODEM);
	linespeed = g_list_append(linespeed, LINE_SPEED_33MODEM);
	linespeed = g_list_append(linespeed, LINE_SPEED_28MODEM);
	linespeed = g_list_append(linespeed, LINE_SPEED_14MODEM);
	
	crit = g_list_append(crit, "AT LEAST");
	crit = g_list_append(crit, "EQUAL TO");
	crit = g_list_append(crit, "AT BEST");
	
	vbox = gtk_vbox_new(FALSE, 0);
	
	frame = gtk_frame_new(FRAME_SEARCH);
	gtk_box_pack_start(GTK_BOX(vbox), frame, FALSE, FALSE, 0);
	gtk_widget_show(frame);
		
	table = gtk_table_new(3,5,FALSE);
	gtk_container_set_border_width(GTK_CONTAINER(table), 5);
	gtk_table_set_row_spacings(GTK_TABLE(table), 4);
	gtk_table_set_col_spacings(GTK_TABLE(table), 4);
	gtk_container_add(GTK_CONTAINER(frame), table);
	gtk_widget_show(table);
	
	sess->clist = gtk_clist_new_with_titles(7, ltitles);
  	gtk_clist_set_shadow_type(GTK_CLIST(sess->clist), GTK_SHADOW_OUT);		
  	gtk_clist_set_selection_mode(GTK_CLIST(sess->clist), GTK_SELECTION_EXTENDED);
	gtk_clist_set_column_width(GTK_CLIST(sess->clist), 0, 300);
	gtk_clist_set_column_width(GTK_CLIST(sess->clist), 1, 50);
	gtk_clist_set_column_width(GTK_CLIST(sess->clist), 2, 40);
	gtk_clist_set_column_width(GTK_CLIST(sess->clist), 3, 40);
	gtk_clist_set_column_width(GTK_CLIST(sess->clist), 4, 40);
	gtk_clist_set_column_width(GTK_CLIST(sess->clist), 5, 70);
	gtk_clist_set_column_width(GTK_CLIST(sess->clist), 6, 60);
	scrolled_window = gtk_scrolled_window_new (NULL, NULL);
   	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	gtk_box_pack_start(GTK_BOX(vbox), scrolled_window, TRUE, TRUE, 0);
   	gtk_widget_show(scrolled_window);
   
   	gtk_container_add (GTK_CONTAINER (scrolled_window), sess->clist);
	gtk_signal_connect(GTK_OBJECT(sess->clist), "select_row", GTK_SIGNAL_FUNC(selection_changed), sess);
	gtk_signal_connect(GTK_OBJECT(sess->clist), "unselect_row", GTK_SIGNAL_FUNC(selection_unselected), sess);
	gtk_signal_connect(GTK_OBJECT(sess->clist), "button_press_event", GTK_SIGNAL_FUNC(search_right_clicked), sess);
	gtk_signal_connect(GTK_OBJECT(sess->clist), "click-column", GTK_SIGNAL_FUNC(search_sort_column), NULL);
	gtk_widget_show(sess->clist);
	
	search_for_label = gtk_label_new(LABEL_SEARCH);
	gtk_label_set_justify(GTK_LABEL(search_for_label), GTK_JUSTIFY_LEFT);
	gtk_table_attach_defaults(GTK_TABLE(table), search_for_label, 0, 1, 0, 1);
	gtk_widget_show(search_for_label);
	
	max_results_label = gtk_label_new(LABEL_RESULTS);
	gtk_label_set_justify(GTK_LABEL(max_results_label), GTK_JUSTIFY_LEFT);
	gtk_table_attach_defaults(GTK_TABLE(table), max_results_label, 0, 1, 1, 2);
	gtk_widget_show(max_results_label);
	
	bitrate_label = gtk_label_new(LABEL_BITRATE);
	gtk_label_set_justify(GTK_LABEL(bitrate_label), GTK_JUSTIFY_LEFT);
	gtk_table_attach_defaults(GTK_TABLE(table), bitrate_label, 2, 3, 0, 1);
	gtk_widget_show(bitrate_label);
	
	freq_label = gtk_label_new(LABEL_FREQUENCY);
	gtk_label_set_justify(GTK_LABEL(freq_label), GTK_JUSTIFY_LEFT);
	gtk_table_attach_defaults(GTK_TABLE(table), freq_label, 2, 3, 1, 2);
	gtk_widget_show(freq_label);
	
	linespeed_label = gtk_label_new(LABEL_LINESPEED);
	gtk_label_set_justify(GTK_LABEL(linespeed_label), GTK_JUSTIFY_LEFT);
	gtk_table_attach_defaults(GTK_TABLE(table), linespeed_label, 2, 3, 2, 3);
	gtk_widget_show(linespeed_label);
	
	sess->search.max_results_entry = gtk_entry_new();
	gtk_table_attach_defaults(GTK_TABLE(table), sess->search.max_results_entry, 1, 2, 1, 2);
	gtk_entry_set_text(GTK_ENTRY(sess->search.max_results_entry), DEFAULT_NROFHITS);
	gtk_widget_show(sess->search.max_results_entry);
	
	sess->search.search_for_entry = gtk_entry_new();
	gtk_table_attach_defaults(GTK_TABLE(table), sess->search.search_for_entry, 1, 2, 0, 1);
	gtk_signal_connect(GTK_OBJECT(sess->search.search_for_entry), "activate", GTK_SIGNAL_FUNC(command_do_search), sess);
	gtk_widget_show(sess->search.search_for_entry);
	
	sess->search.bitrate_combo = gtk_combo_new();
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(sess->search.bitrate_combo)->entry), FALSE);
	gtk_widget_set_usize(sess->search.bitrate_combo, 110, 0);
	gtk_combo_set_popdown_strings(GTK_COMBO(sess->search.bitrate_combo), bitrate);
	gtk_table_attach_defaults(GTK_TABLE(table), sess->search.bitrate_combo, 4, 5, 0, 1);
	gtk_widget_show(sess->search.bitrate_combo);
	
	sess->search.freq_combo = gtk_combo_new();
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(sess->search.freq_combo)->entry), FALSE);
	gtk_widget_set_usize(sess->search.freq_combo, 110, 0);
	gtk_combo_set_popdown_strings(GTK_COMBO(sess->search.freq_combo), freq);
	gtk_table_attach_defaults(GTK_TABLE(table), sess->search.freq_combo, 4, 5, 1, 2);
	gtk_widget_show(sess->search.freq_combo);
	
	sess->search.linespeed_combo = gtk_combo_new();
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(sess->search.linespeed_combo)->entry), FALSE);
	gtk_widget_set_usize(sess->search.linespeed_combo, 110, 0);
	gtk_combo_set_popdown_strings(GTK_COMBO(sess->search.linespeed_combo), linespeed);
	gtk_table_attach_defaults(GTK_TABLE(table), sess->search.linespeed_combo, 4, 5, 2, 3);
	gtk_widget_show(sess->search.linespeed_combo);	

	sess->search.bitrate_crit = gtk_combo_new();
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(sess->search.bitrate_crit)->entry), FALSE);
	gtk_widget_set_usize(sess->search.bitrate_crit, 90, 0);
	gtk_combo_set_popdown_strings(GTK_COMBO(sess->search.bitrate_crit), crit);
	gtk_table_attach_defaults(GTK_TABLE(table), sess->search.bitrate_crit, 3, 4, 0, 1);
	gtk_widget_show(sess->search.bitrate_crit);	
	
	sess->search.freq_crit = gtk_combo_new();
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(sess->search.freq_crit)->entry), FALSE);
	gtk_widget_set_usize(sess->search.freq_crit, 90, 0);
	gtk_combo_set_popdown_strings(GTK_COMBO(sess->search.freq_crit), crit);
	gtk_table_attach_defaults(GTK_TABLE(table), sess->search.freq_crit, 3, 4, 1, 2);
	gtk_widget_show(sess->search.freq_crit);	
	
	sess->search.linespeed_crit = gtk_combo_new();
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(sess->search.linespeed_crit)->entry), FALSE);
	gtk_widget_set_usize(sess->search.linespeed_crit, 90, 0);
	gtk_combo_set_popdown_strings(GTK_COMBO(sess->search.linespeed_crit), crit);
	gtk_table_attach_defaults(GTK_TABLE(table), sess->search.linespeed_crit, 3, 4, 2, 3);
	gtk_widget_show(sess->search.linespeed_crit);
	
	search_button = gtk_button_new_with_label(BUTTON_FIND);
	gtk_table_attach_defaults(GTK_TABLE(table), search_button, 0, 2, 2, 3);
	gtk_signal_connect(GTK_OBJECT(search_button), "clicked", GTK_SIGNAL_FUNC(command_do_search), sess);
	gtk_widget_show(search_button);

	return vbox;
}

void make_chat_box(gtk_sess *sess, gchar *name, gint list)
{
	GtkWidget *vbox;
	GtkWidget *label;
	GtkWidget *hpaned;
	GtkWidget *scrolled_window;
	
	gchar *ltitles[3] = {COLUMN_USER, COLUMN_SONGS, COLUMN_SPEED};
	
	vbox = gtk_vbox_new(FALSE, 0);
	label = gtk_label_new(name);
	gtk_notebook_append_page (GTK_NOTEBOOK (sess->notebook), vbox, label);
	gtk_widget_show(vbox);
	
	if((sess->nr_chatwins) > 0)
	{
		sess->chatwins = (gtk_chat_window *) g_realloc(sess->chatwins, (sizeof(gtk_chat_window)*(sess->nr_chatwins+1)));
		memset(&sess->chatwins[sess->nr_chatwins], 0, sizeof(gtk_chat_window));
	}
	else
	{
		sess->chatwins = (gtk_chat_window *) g_malloc(sizeof(gtk_chat_window));
		memset(sess->chatwins, 0, sizeof(gtk_chat_window));
	}	
	
	if(list == TRUE)
	{
		hpaned = gtk_hpaned_new();
		gtk_box_pack_start(GTK_BOX(vbox), hpaned, TRUE, TRUE, 0);
		gtk_widget_show(hpaned);
		
		sess->chatwins[sess->nr_chatwins].ctext = gtk_text_new(NULL, NULL);
		gtk_paned_add1(GTK_PANED(hpaned), sess->chatwins[sess->nr_chatwins].ctext);
		gtk_widget_show(sess->chatwins[sess->nr_chatwins].ctext);
	
		sess->chatwins[sess->nr_chatwins].clist = gtk_clist_new_with_titles(3, ltitles);
		
		gtk_clist_set_column_width(GTK_CLIST(sess->chatwins[sess->nr_chatwins].clist), 0, 70);
		gtk_clist_set_column_width(GTK_CLIST(sess->chatwins[sess->nr_chatwins].clist), 1, 40);
		gtk_clist_set_column_width(GTK_CLIST(sess->chatwins[sess->nr_chatwins].clist), 2, 50);
   		gtk_clist_set_shadow_type (GTK_CLIST(sess->chatwins[sess->nr_chatwins].clist), GTK_SHADOW_OUT);		
		gtk_widget_show(sess->chatwins[sess->nr_chatwins].clist);	

		scrolled_window = gtk_scrolled_window_new (NULL, NULL);
   		gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
   		gtk_container_add(GTK_CONTAINER (scrolled_window), sess->chatwins[sess->nr_chatwins].clist);
   	
		gtk_signal_connect(GTK_OBJECT(sess->chatwins[sess->nr_chatwins].clist), "button_press_event", GTK_SIGNAL_FUNC(chat_right_clicked), sess);
		gtk_signal_connect(GTK_OBJECT(sess->chatwins[sess->nr_chatwins].clist), "click-column", GTK_SIGNAL_FUNC(chat_sort_column), NULL);
		gtk_widget_show(scrolled_window);

		gtk_paned_add2(GTK_PANED(hpaned), scrolled_window);
		gtk_paned_set_position(GTK_PANED(hpaned), 430);
	}
	else
	{
		sess->chatwins[sess->nr_chatwins].ctext = gtk_text_new(NULL, NULL);
		gtk_box_pack_start(GTK_BOX(vbox), sess->chatwins[sess->nr_chatwins].ctext, TRUE, TRUE, 0);
		gtk_widget_show(sess->chatwins[sess->nr_chatwins].ctext);
	}
	
	sess->chatwins[sess->nr_chatwins].cmsg = gtk_entry_new();
	gtk_box_pack_start(GTK_BOX(vbox), sess->chatwins[sess->nr_chatwins].cmsg, FALSE, FALSE, 0);
	gtk_widget_show(sess->chatwins[sess->nr_chatwins].cmsg);
	
	gtk_signal_connect(GTK_OBJECT(sess->chatwins[sess->nr_chatwins].cmsg), "activate", GTK_SIGNAL_FUNC(read_command), sess);
	
	strcpy(sess->chatwins[sess->nr_chatwins].name, name);
	
	sess->nr_chatwins++;
}

GtkWidget *make_library_page(gtk_sess *sess)
{
	GtkWidget *scrolled_window;
	
	gchar *titles[5] = {COLUMN_FILENAME,COLUMN_FILESIZE,COLUMN_BITRATE,COLUMN_FREQ, COLUMN_LENGTH};
	
	scrolled_window = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	sess->library_clist = gtk_clist_new_with_titles(5, titles);
	gtk_clist_set_shadow_type(GTK_CLIST(sess->library_clist), GTK_SHADOW_OUT);
  	gtk_clist_set_selection_mode(GTK_CLIST(sess->library_clist), GTK_SELECTION_EXTENDED);

	gtk_clist_set_column_width(GTK_CLIST(sess->library_clist), 0, 360);
	gtk_clist_set_column_width(GTK_CLIST(sess->library_clist), 1, 50);
	gtk_clist_set_column_width(GTK_CLIST(sess->library_clist), 2, 75);
	gtk_clist_set_column_width(GTK_CLIST(sess->library_clist), 3, 70);

	gtk_signal_connect(GTK_OBJECT(sess->library_clist), "select_row", GTK_SIGNAL_FUNC(library_selection_changed), sess);
	gtk_signal_connect(GTK_OBJECT(sess->library_clist), "unselect_row", GTK_SIGNAL_FUNC(library_selection_unselected), sess);
	gtk_signal_connect(GTK_OBJECT(sess->library_clist), "button_press_event", GTK_SIGNAL_FUNC(library_right_clicked), sess);
	gtk_signal_connect(GTK_OBJECT(sess->library_clist), "click-column", GTK_SIGNAL_FUNC(library_sort_column), NULL);
   	gtk_container_add(GTK_CONTAINER(scrolled_window), sess->library_clist);
   	gtk_widget_show(sess->library_clist);
	
	return scrolled_window;
}

GtkWidget *make_transfer_page(gtk_sess *sess)
{
	GtkWidget *scrolled_window;
	GtkWidget *scrolled_window2;
	GtkWidget *vbox;
	GtkWidget *table;
	
	gchar *titles[6] = {COLUMN_FILENAME, COLUMN_FILESIZE, COLUMN_PROGRESS, COLUMN_USER, COLUMN_LINESPEED, COLUMN_STATUS};
	
	vbox = gtk_vbox_new(FALSE, 0);
	
	table = gtk_table_new(1,3,TRUE);

	scrolled_window = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	
	scrolled_window2 = gtk_scrolled_window_new (NULL, NULL);
	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window2), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	
	sess->transfer_list = gtk_clist_new_with_titles(6, titles);
  	gtk_clist_set_selection_mode(GTK_CLIST(sess->transfer_list), GTK_SELECTION_EXTENDED);
	gtk_signal_connect(GTK_OBJECT(sess->transfer_list), "select_row", GTK_SIGNAL_FUNC(transfer_selection_changed), sess);
	gtk_signal_connect(GTK_OBJECT(sess->transfer_list), "unselect_row", GTK_SIGNAL_FUNC(transfer_selection_unselected), sess);
	gtk_signal_connect(GTK_OBJECT(sess->transfer_list), "button_press_event", GTK_SIGNAL_FUNC(download_right_clicked), sess);
	gtk_signal_connect(GTK_OBJECT(sess->transfer_list), "click-column", GTK_SIGNAL_FUNC(transfer_sort_column), NULL);

  	gtk_clist_set_shadow_type(GTK_CLIST(sess->transfer_list), GTK_SHADOW_OUT);		

	gtk_clist_set_column_width(GTK_CLIST(sess->transfer_list), 0, 285);
	gtk_clist_set_column_width(GTK_CLIST(sess->transfer_list), 1, 50);
	gtk_clist_set_column_width(GTK_CLIST(sess->transfer_list), 2, 75);
	gtk_clist_set_column_width(GTK_CLIST(sess->transfer_list), 3, 70);
	gtk_clist_set_column_width(GTK_CLIST(sess->transfer_list), 4, 70);
	
	sess->ul_list = gtk_clist_new_with_titles(6, titles);
  	gtk_clist_set_selection_mode(GTK_CLIST(sess->ul_list), GTK_SELECTION_EXTENDED);
	gtk_signal_connect(GTK_OBJECT(sess->ul_list), "select_row", GTK_SIGNAL_FUNC(upload_selection_changed), sess);
	gtk_signal_connect(GTK_OBJECT(sess->ul_list), "unselect_row", GTK_SIGNAL_FUNC(upload_selection_unselected), sess);
	gtk_signal_connect(GTK_OBJECT(sess->ul_list), "button_press_event", GTK_SIGNAL_FUNC(upload_right_clicked), sess);
	gtk_signal_connect(GTK_OBJECT(sess->ul_list), "click-column", GTK_SIGNAL_FUNC(transfer_sort_column), NULL);

  	gtk_clist_set_shadow_type(GTK_CLIST(sess->ul_list), GTK_SHADOW_OUT);		

	gtk_clist_set_column_width(GTK_CLIST(sess->ul_list), 0, 285);
	gtk_clist_set_column_width(GTK_CLIST(sess->ul_list), 1, 50);
	gtk_clist_set_column_width(GTK_CLIST(sess->ul_list), 2, 75);
	gtk_clist_set_column_width(GTK_CLIST(sess->ul_list), 3, 70);
	gtk_clist_set_column_width(GTK_CLIST(sess->ul_list), 4, 70);
	
   gtk_container_add(GTK_CONTAINER(scrolled_window2), sess->ul_list);
   gtk_widget_show(sess->ul_list);
   
   gtk_container_add(GTK_CONTAINER(scrolled_window), sess->transfer_list);
   gtk_widget_show(sess->transfer_list);
   
	gtk_box_pack_start(GTK_BOX(vbox), scrolled_window, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), scrolled_window2, TRUE, TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), table, FALSE, FALSE, 0);
	gtk_widget_show(scrolled_window);
	gtk_widget_show(scrolled_window2);

	gtk_widget_show(table);	
   
	return vbox;
}

GtkWidget *make_pixmapwid(GtkWidget *parent, gchar *name[])
{
	GdkPixmap *pixmap;
	GdkBitmap *mask;
	GtkStyle *style;
	
	gtk_widget_show( parent );
	
	style = gtk_widget_get_style(parent);
	pixmap = gdk_pixmap_create_from_xpm_d (parent->window, &mask, &style->bg[GTK_STATE_NORMAL], (gchar **)name);
	
	return gtk_pixmap_new (pixmap, mask);
}

GtkWidget *make_toolbar(GtkWidget *parent, gtk_sess *sess)
{
	GtkWidget *toolbar;
	
	toolbar = gtk_toolbar_new(GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);

	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), TOOLBAR_CONNECT, TOOLTIP_CONNECT, TOOLBAR_CONNECT, make_pixmapwid(parent, connect_xpm), GTK_SIGNAL_FUNC(connect_dialog), sess);
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), TOOLBAR_DISCONNECT, TOOLTIP_DISCONNECT, TOOLBAR_DISCONNECT, make_pixmapwid(parent, disconnect_xpm), GTK_SIGNAL_FUNC(disconnect_napster), sess);
	gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), TOOLBAR_CHAT, TOOLTIP_CHAT, TOOLBAR_CHAT, make_pixmapwid(parent, chat_xpm), GTK_SIGNAL_FUNC(change_to_chat), sess);
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), TOOLBAR_SEARCH, TOOLTIP_SEARCH, TOOLBAR_SEARCH, make_pixmapwid(parent, search_xpm), GTK_SIGNAL_FUNC(change_to_search), sess);	
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), TOOLBAR_HOTLIST, TOOLTIP_HOTLIST, TOOLBAR_HOTLIST, make_pixmapwid(parent, hotlist_xpm), GTK_SIGNAL_FUNC(change_to_hotlist), sess);	
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), TOOLBAR_LIBRARY, TOOLTIP_LIBRARY, TOOLBAR_LIBRARY, make_pixmapwid(parent, library_xpm), GTK_SIGNAL_FUNC(change_to_library), sess);	
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), TOOLBAR_TRANSFER, TOOLTIP_TRANSFER, TOOLBAR_TRANSFER, make_pixmapwid(parent, transfer_xpm), GTK_SIGNAL_FUNC(change_to_transfer), sess);	
	gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), TOOLBAR_QUIT, TOOLTIP_QUIT, TOOLBAR_QUIT, make_pixmapwid(parent, exit_xpm), GTK_SIGNAL_FUNC(destroy), sess);	
	gtk_toolbar_append_space(GTK_TOOLBAR(toolbar));
	gtk_toolbar_append_item(GTK_TOOLBAR(toolbar), TOOLBAR_ABOUT, TOOLTIP_ABOUT, TOOLBAR_ABOUT, make_pixmapwid(parent, about_xpm), GTK_SIGNAL_FUNC(about_napster), NULL);	

	return toolbar;
}

gint main (gint argc, gchar *argv[])
{
	GtkWidget *menu;
	GtkWidget *vbox;
	GtkWidget *label1;
	GtkWidget *label2;
	GtkWidget *label3;	
	GtkWidget *label4;
	GtkWidget *label5;
	GtkWidget *search;
	GtkWidget *hotlist;
	GtkWidget *toolbar;
	GtkWidget *menuhandle;
	GtkWidget *toolhandle;
	GtkWidget *transfer_page;
	GtkWidget *library_page;
	GtkStyle *style;
	
	gtk_sess *sess;
	sess = (gtk_sess *)g_malloc(sizeof(gtk_sess));
	
	gtk_init(&argc, &argv);

	memset(sess, 0, sizeof(gtk_sess));

	sess->window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(sess->window), TITLEBAR_MAIN);
	gtk_signal_connect(GTK_OBJECT(sess->window), "destroy", GTK_SIGNAL_FUNC(destroy), sess);
	gtk_widget_set_usize (sess->window, 700, 500);

	hotlist = make_hotlist_page(sess);
	search = make_search_page(sess);

	ReadRCFile(sess);

	vbox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(sess->window), vbox);	
	gtk_widget_show(vbox);
	
	menuhandle = gtk_handle_box_new();
	gtk_box_pack_start(GTK_BOX(vbox), menuhandle, FALSE, FALSE, 0);
	gtk_widget_show(menuhandle);
	
	menu = make_menu(sess);
	gtk_container_add(GTK_CONTAINER(menuhandle), menu);
	gtk_widget_show(menu);
	
	sess->page = gtk_notebook_new();	

	toolhandle = gtk_handle_box_new();
	gtk_box_pack_start(GTK_BOX(vbox), toolhandle, FALSE, FALSE, 0);
	gtk_widget_show(toolhandle);
	
	toolbar = make_toolbar(sess->window, sess);
	gtk_container_add(GTK_CONTAINER(toolhandle), toolbar);
	gtk_widget_show(toolbar);

	gtk_notebook_set_show_tabs(GTK_NOTEBOOK (sess->page), sess->SHOW_TABS);
	gtk_box_pack_start(GTK_BOX(vbox), sess->page, TRUE, TRUE, 0);
	gtk_widget_show(sess->page);

	sess->notebook = gtk_notebook_new();
	gtk_notebook_set_tab_pos (GTK_NOTEBOOK (sess->notebook), GTK_POS_TOP);
	label1 = gtk_label_new(NOTEBOOK_LABEL_CHAT);
	gtk_notebook_append_page (GTK_NOTEBOOK (sess->page), sess->notebook, label1);
	gtk_widget_show(sess->notebook);

	label2 = gtk_label_new(NOTEBOOK_LABEL_SEARCH);
	gtk_notebook_append_page (GTK_NOTEBOOK (sess->page), search, label2);
	gtk_widget_show(search);
	
	label4 = gtk_label_new(NOTEBOOK_LABEL_HOTLIST);
	gtk_notebook_append_page (GTK_NOTEBOOK (sess->page), hotlist, label4);
	gtk_widget_show(hotlist);
	
	library_page = make_library_page(sess);
	label5 = gtk_label_new(NOTEBOOK_LABEL_LIBRARY);
	gtk_notebook_append_page (GTK_NOTEBOOK (sess->page), library_page, label5);
	gtk_widget_show(library_page);
	
	transfer_page = make_transfer_page(sess);
	label3 = gtk_label_new(NOTEBOOK_LABEL_TRANSFER);
	gtk_notebook_append_page (GTK_NOTEBOOK (sess->page), transfer_page, label3);
	gtk_widget_show(transfer_page);
	
	sess->statusbar = gtk_statusbar_new();
	gtk_box_pack_start(GTK_BOX(vbox), sess->statusbar, FALSE, FALSE, 0);
	gtk_widget_show(sess->statusbar);
	gtk_statusbar_push(GTK_STATUSBAR(sess->statusbar), 1, STATUSBAR_WELCOME);	
	
	gtk_widget_show(sess->window);

	style = gtk_widget_get_style(sess->window);
	sess->pixmaps.pm_red = gdk_pixmap_create_from_xpm_d (sess->window->window, &sess->pixmaps.bm_red, &style->bg[GTK_STATE_NORMAL], red_xpm);
	sess->pixmaps.pm_green = gdk_pixmap_create_from_xpm_d (sess->window->window, &sess->pixmaps.bm_green, &style->bg[GTK_STATE_NORMAL], green_xpm);
	sess->pixmaps.pm_gold = gdk_pixmap_create_from_xpm_d (sess->window->window, &sess->pixmaps.bm_gold, &style->bg[GTK_STATE_NORMAL], gold_xpm);

	if(sess->AUTO_CONNECT) connect_dialog(NULL, (gpointer)sess);

	gtk_main();
	return 0;
}