/* GTK Napster-0.301
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _MENU_H_
#define _MENU_H_

#include "xpm/connect.xpm"
#include "xpm/disconnect.xpm"
#include "xpm/chat.xpm"
#include "xpm/search.xpm"
#include "xpm/hotlist.xpm"
#include "xpm/library.xpm"
#include "xpm/transfer.xpm"
#include "xpm/exit.xpm"
#include "xpm/about.xpm"

#include "xpm/red.xpm"
#include "xpm/green.xpm"
#include "xpm/gold.xpm"

#define DEFAULT_NROFHITS "100"

#define STATUSBAR_WELCOME 				"Not connected: Welcome to GTK-Napster!"

#define ABOUT 										"By Unified\nVersion 0.201\nFebruary 2000\ne-mail: \"xilliator@hotmail.com\""
#define ABOUT_TITLE 							"About Napster"

#define NOTEBOOK_LABEL_CHAT 			"Chat"
#define NOTEBOOK_LABEL_TRANSFER 	"Transfer"
#define NOTEBOOK_LABEL_SEARCH 		"Search"
#define NOTEBOOK_LABEL_LIBRARY 		"Search"
#define NOTEBOOK_LABEL_HOTLIST		"Hotlist"

#define LABEL_SEARCH 							"Search for"
#define LABEL_RESULTS 						"Max results"
#define LABEL_BITRATE 						"Bitrate must be"
#define LABEL_FREQUENCY 					"Frequency must be"
#define LABEL_LINESPEED 					"Line speed must be"

#define TOOLBAR_CONNECT 					"Connect"
#define TOOLTIP_CONNECT 					"Connect to Napster Server."
#define TOOLBAR_DISCONNECT 				"Disconnect"
#define TOOLTIP_DISCONNECT 				"Disconnect from Napster Server."
#define TOOLBAR_CHAT 							"Chat"
#define TOOLTIP_CHAT 							"Chat with other people."
#define TOOLBAR_SEARCH 						"Search"
#define TOOLTIP_SEARCH 						"Search for music."
#define TOOLBAR_HOTLIST						"Hotlist"
#define TOOLTIP_HOTLIST						"Browse the hotlist."
#define TOOLBAR_TRANSFER 					"Transfer"
#define TOOLTIP_TRANSFER 					"Look at transfer status."
#define TOOLBAR_LIBRARY 					"Library"
#define TOOLTIP_LIBRARY 					"Look at files you are sharing."
#define TOOLBAR_QUIT 							"Quit"
#define TOOLTIP_QUIT 							"Quit Napster."
#define TOOLBAR_ABOUT 						"About"
#define TOOLTIP_ABOUT 						"About Napster"

#define BUTTON_CANCELDOWNLOAD 		"Cancel Download"
#define BUTTON_CLEARDOWNLOAD 			"Clear Item"
#define BUTTON_PLAYFILE			 			"Open Item"
#define BUTTON_FIND 							"Find it!"
#define BUTTON_GET 							"Get File..."

#define FRAME_SEARCH							"Search Fields"

void disconnect_napster(GtkWidget *widget, gpointer data);
void destroy(GtkWidget *widget, gpointer data);
void change_to_chat(GtkWidget *widget, gpointer data);
void change_to_search(GtkWidget *widget, gpointer data);
void change_to_library(GtkWidget *widget, gpointer data);
void change_to_hotlist(GtkWidget *widget, gpointer data);
void change_to_transfer(GtkWidget *widget, gpointer data);
void about_napster(GtkWidget *widget, gpointer data);
gint get_chat_box_nr(gtk_sess *sess, gchar *name);
GtkWidget *make_search_page(gtk_sess *sess);
void make_chat_box(gtk_sess *sess, gchar *name, gint list);
GtkWidget *make_library_page(gtk_sess *sess);
GtkWidget *make_transfer_page(gtk_sess *sess);
GtkWidget *make_pixmapwid(GtkWidget *parent, gchar *name[]);
GtkWidget *make_toolbar(GtkWidget *parent, gtk_sess *sess);
gint main (gint argc, gchar *argv[]);

#endif
