/* GTK Napster-0.301
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _NCOMMAND_H_
#define _NCOMMAND_H_

#define MSGBOX_ERROR_TITLE 			"Error!"
#define COLOR_ALLOC_ERROR 			"couldn't allocate color"
#define STRANGE_LINESPEED 			"Error"

#define RESUME_FINISHED				"Finished receiving all"

#define WARNING_WRITE_CHANNEL 		"Unknown error when trying to write to channel"

/* 1=Channel */
#define WARNING_GET_CHANNEL 		"Unknown error when getting channel %s."

/* 1=Username */
#define PING_REPLY_USER 			"- Ping reply from %s." 
#define PING_REPLY_SERVER 			"- Ping reply from server. (%s)"

/* 1=Code, 2=Message */
#define UNKNOWN_COMMAND 			"\nCommand nr: %d is unknown. Message is: %s\n"

/* 1=Username, 2=Songs, 3=Line Speed */
#define USER_JOIN_MSG 				"%s has joined. Sharing %s songs. (%s)"
#define USER_LEAVE_MSG 				"%s has left. Sharing %s songs. (%s)"

/* 1=Username, 2=Level, 3=Time, 4=Channels, 5=Ability, 6=Songs, 7=Downloading, 8=Uploading, 9=Line Speed, 10=Version */
#define USER_WHOIS_MSG 				"User: %s\nLevel: %s\nTime: %s\nChannel(s): %s\nAbility: %s\nShared songs: %s\nDownloading: %s songs\nUploading: %s songs\nLine speed: %s\nVersion: %s"
#define MSGBOX_WHOIS_TITLE 			"Whois!"

/* 1=Username, 2=Level, 3=Time */
#define USER_WHOIS_OFF_MSG			"User: %s\nLevel: %s\nLast seen: %s"
#define MSGBOX_WHOIS_OFF_TITLE		"User Offline!"
#define USER_WHOIS_OFF_UNKNOWN		"Unknown"

/* 1=Username, 2=Message */
#define USER_TELL_MSG 				"- %s tells you: %s"

/* 1=Songs 2=GigaByte 3=Libraries */
#define STATUSBAR_CONNECTED 		"Connected: %s songs (%s GB) in %s libraries."

gboolean seperate_string(gchar *instr, gchar **outlist, gint nr);
void string_out(GtkWidget *widget, gchar *instr, gint red, gint green, gint blue);
void red_print(gtk_sess *sess, gchar *instr);
void ping_back(gtk_sess *sess, gchar *instr, gboolean you);
void unknown_command(gtk_sess *sess, gchar *instr, gint code);
char *get_speed(gint speed);
gint get_speed_nr(gchar *in);
void command_connect(gtk_sess *sess, gchar *instr);
void destroy_list(gpointer data);
void command_search_results(gtk_sess *sess, gchar *instr);
void command_search_notfound(gtk_sess *sess);
void command_resume_notfound(gtk_sess *sess);
void command_leave(gtk_sess *sess, gchar *instr);
void command_whois_ans(gtk_sess *sess, gchar *instr);
void command_whois_offline_ans(gtk_sess *sess, gchar *instr);
void command_join_list(gtk_sess *sess, gchar *instr);
void command_join_welcome(gtk_sess *sess, gchar *instr);
void command_verify_ul(gtk_sess *sess, gchar *instr);
void command_server_info(gtk_sess *sess, gchar *instr);
void command_fail(gtk_sess *sess, gchar *instr);
void command_get_msg(gtk_sess *sess, gchar *instr);
void command_get_tell(gtk_sess *sess, gchar *instr);
void command_resume_list(gtk_sess *sess, gchar *instr);
void read_command_run(gtk_sess *sess, gint code, gchar *instr);

#endif