/* GTK Napster-0.301
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <string.h>
#include <stdlib.h>

#include "common.h"
#include "ndialog.h"

void ReadRCFile(gtk_sess *sess)
{
	gchar *filename[160];
	gchar buffer[160];
	FILE *rcfile;
	gchar *username;
	
	strcpy((gchar *)sess->directory, getenv("HOME"));
	sprintf((gchar *)sess->sharedir, "%s/%s", getenv("HOME"), "shared.dat");
	sess->speed = 0;
	strcpy((gchar *)sess->email, DEFAULT_EMAIL);
	strcpy((gchar *)sess->exec_player, DEFAULT_PLAYER);
	sess->timeout = 30;
	sess->maxdls = 3;
	sess->maxuls = 3;
	sess->port = 6699;
	
	sprintf((gchar *)filename, "%s/%s", getenv("HOME"), RC_FILENAME);
	
	if((rcfile = fopen((gchar *)filename, "r")) == NULL)
	{
		g_warning(WARNING_FILE_NOT_FOUND, (gchar *)filename);
		return;
	}
		
	while(fgets(buffer, 160, rcfile) != NULL)
	{
		buffer[strlen(buffer)-1] = '\0';
		
		if((strstr((gchar *)buffer, "USERNAME=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 29))
		{
			sprintf((gchar *)sess->username, "%s", &buffer[9]);
		}
		if((strstr((gchar *)buffer, "PASSWORD=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 29))
		{
			sprintf((gchar *)sess->password, "%s", &buffer[9]);
		}
		else if((strstr((gchar *)buffer, "STORE_DIR=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 110))
		{
			sprintf((gchar *)sess->directory, "%s", &buffer[10]);
		}
		else if((strstr((gchar *)buffer, "SHARE_FILE=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 161))
		{
			sprintf((gchar *)sess->sharedir, "%s", &buffer[11]);
		}
		else if((strstr((gchar *)buffer, "E-MAIL=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 107))
		{
			sprintf((gchar *)sess->email, "%s", &buffer[7]);
		}
		else if((strstr((gchar *)buffer, "LINE_SPEED=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 31))
		{
			sess->speed = atoi(&buffer[11]);
		}
		else if((strstr((gchar *)buffer, "TIMEOUT=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 12))
		{
			sess->timeout = atoi(&buffer[8]);
		}
		else if((strstr((gchar *)buffer, "MAX_DOWNLOADS=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 18))
		{
			sess->maxdls = atoi(&buffer[14]);
		}
		else if((strstr((gchar *)buffer, "MAX_UPLOADS=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 16))
		{
			sess->maxuls = atoi(&buffer[12]);
		}
		else if((strstr((gchar *)buffer, "PORT=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 10))
		{
			sess->port = atoi(&buffer[5]);
		}
		else if((strstr((gchar *)buffer, "FIREWALL=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 11))
		{
			sess->FIREWALL = (gboolean)atoi(&buffer[9]);
		}
		else if((strstr((gchar *)buffer, "SHOW_TABS=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 12))
		{
			sess->SHOW_TABS = (gboolean)atoi(&buffer[10]);
		}
		else if((strstr((gchar *)buffer, "SHOW_DHMS=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 12))
		{
			sess->SHOW_DHMS = (gboolean)atoi(&buffer[10]);
		}
		else if((strstr((gchar *)buffer, "SHOW_BYTE=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 12))
		{
			sess->SHOW_BYTE = (gboolean)atoi(&buffer[10]);
		}
		else if((strstr((gchar *)buffer, "REMEMBER_PASSWORD=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 20))
		{
			sess->PASSWORD = (gboolean)atoi(&buffer[18]);
		}
		else if((strstr((gchar *)buffer, "SWITCH_TO_TRANSFER=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 21))
		{
			sess->SWITCH_TRANSFER = (gboolean)atoi(&buffer[19]);
		}
		else if((strstr((gchar *)buffer, "AUTO_CONNECT=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 15))
		{
			sess->AUTO_CONNECT = (gboolean)atoi(&buffer[13]);
		}
		else if((strstr((gchar *)buffer, "PLAYER=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 157))
		{
			sprintf((gchar *)sess->exec_player, "%s", &buffer[7]);
		}
		else if((strstr((gchar *)buffer, "BITRATE_COMP=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 40))
		{
			gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(sess->search.bitrate_crit)->entry), &buffer[13]);
		}
		else if((strstr((gchar *)buffer, "BITRATE=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 40))
		{
			gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(sess->search.bitrate_combo)->entry), &buffer[8]);
		}
		else if((strstr((gchar *)buffer, "FREQ_COMP=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 40))
		{
			gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(sess->search.freq_crit)->entry), &buffer[10]);
		}
		else if((strstr((gchar *)buffer, "FREQ=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 40))
		{
			gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(sess->search.freq_combo)->entry), &buffer[5]);
		}
		else if((strstr((gchar *)buffer, "SPEED_COMP=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 40))
		{
			gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(sess->search.linespeed_crit)->entry), &buffer[11]);
		}
		else if((strstr((gchar *)buffer, "SPEED=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 40))
		{
			gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(sess->search.linespeed_combo)->entry), &buffer[6]);
		}
		else if((strstr((gchar *)buffer, "HOTLIST=") == (gchar *)buffer) && (strlen((gchar *)buffer) < 28))
		{
			username = &buffer[8];
			gtk_clist_append(GTK_CLIST(sess->hotlist.offlinelist), &username);
		}
	}
	
	fclose(rcfile);
}

void get_hotlist_users(gtk_sess *sess, FILE *rcfile)
{
	GdkPixmap *pixm;
	GdkBitmap *bitm;
	gint spacing;
	gint row = 0;
	gchar *username;
	
	while(gtk_clist_get_pixtext(GTK_CLIST(sess->hotlist.onlinelist), row, 0, &username, (guint8*)&spacing, &pixm, &bitm) != 0)
	{
		fprintf(rcfile, "HOTLIST=%s\n", username);
		row++;
	}
	
	row = 0;
	
	while(gtk_clist_get_text(GTK_CLIST(sess->hotlist.offlinelist), row, 0, &username) != 0)
	{
		fprintf(rcfile, "HOTLIST=%s\n", username);
		row++;
	}
}

void WriteSharedFile(gtk_sess *sess)
{
	FILE *sharefile;
	gint i=0;
	gchar *str;
	shared_parm *parm;
	
	if((sharefile = fopen((gchar *)sess->sharedir, "w")) == NULL)
	{
		g_warning(WARNING_CANNOT_WRITE, (gchar *)sess->sharedir);
		return;
	}

	while((parm = (shared_parm *)gtk_clist_get_row_data(GTK_CLIST(sess->library_clist), i)) != NULL)
	{
		gtk_clist_get_text(GTK_CLIST(sess->library_clist), i, 0, &str);
		fprintf(sharefile, "\"%s\" ", str);
		fprintf(sharefile, "%s ", parm->md5);
		fprintf(sharefile, "%.0f ", parm->size);
		gtk_clist_get_text(GTK_CLIST(sess->library_clist), i, 2, &str);
		fprintf(sharefile, "%s ", str);
		gtk_clist_get_text(GTK_CLIST(sess->library_clist), i, 3, &str);
		fprintf(sharefile, "%s ", str);
		fprintf(sharefile, "%d\n", parm->time);
		i++;
	}
	
	fclose(sharefile);
}

void WriteRCFile(gtk_sess *sess)
{
	gchar *filename[200];
	FILE *rcfile;
	
	sprintf((gchar *)filename, "%s/%s", getenv("HOME"), RC_FILENAME);
	
	if((rcfile = fopen((gchar *)filename, "w")) == NULL)
	{
		g_warning(WARNING_CANNOT_WRITE, (gchar *)filename);
		return;
	}
		
	fprintf(rcfile, "USERNAME=%s\n", (gchar *)sess->username);
	if(sess->PASSWORD) fprintf(rcfile, "PASSWORD=%s\n", (gchar *)sess->password);
	fprintf(rcfile, "LINE_SPEED=%d\n", sess->speed);
	fprintf(rcfile, "STORE_DIR=%s\n", (gchar *)sess->directory);
	fprintf(rcfile, "SHARE_FILE=%s\n", (gchar *)sess->sharedir);
	fprintf(rcfile, "E-MAIL=%s\n", (gchar *)sess->email);
	fprintf(rcfile, "SHOW_TABS=%d\n", (gint)sess->SHOW_TABS);
	fprintf(rcfile, "SHOW_DHMS=%d\n", (gint)sess->SHOW_DHMS);
	fprintf(rcfile, "SHOW_BYTE=%d\n", (gint)sess->SHOW_BYTE);
	fprintf(rcfile, "REMEMBER_PASSWORD=%d\n", (gint)sess->PASSWORD);
	fprintf(rcfile, "SWITCH_TO_TRANSFER=%d\n", (gint)sess->SWITCH_TRANSFER);
	fprintf(rcfile, "AUTO_CONNECT=%d\n", (gint)sess->AUTO_CONNECT);
	fprintf(rcfile, "PLAYER=%s\n", (gchar *)sess->exec_player);
	fprintf(rcfile, "TIMEOUT=%d\n", sess->timeout);
	fprintf(rcfile, "MAX_DOWNLOADS=%d\n", sess->maxdls);
	fprintf(rcfile, "MAX_UPLOADS=%d\n", sess->maxuls);	
	fprintf(rcfile, "PORT=%d\n", sess->port);
	fprintf(rcfile, "FIREWALL=%d\n", (gint)sess->FIREWALL);
	fprintf(rcfile, "BITRATE=%s\n", (gchar *)gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sess->search.bitrate_combo)->entry)));
	fprintf(rcfile, "BITRATE_COMP=%s\n", (gchar *)gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sess->search.bitrate_crit)->entry)));
	fprintf(rcfile, "FREQ=%s\n", (gchar *)gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sess->search.freq_combo)->entry)));
	fprintf(rcfile, "FREQ_COMP=%s\n", (gchar *)gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sess->search.freq_crit)->entry)));
	fprintf(rcfile, "SPEED=%s\n", (gchar *)gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sess->search.linespeed_combo)->entry)));
	fprintf(rcfile, "SPEED_COMP=%s\n", (gchar *)gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sess->search.linespeed_crit)->entry)));
	get_hotlist_users(sess, rcfile);
	
	fclose(rcfile);
}

void gtk_message_warning(gchar *message, gchar *title)
{
	GtkWidget *dialog;
	GtkWidget *label;
	GtkWidget *button;
	GtkWidget *table;
	GtkWidget *picture;
	GtkWidget *frame;
	
	dialog = gtk_dialog_new();

	gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
	gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
	gtk_window_set_title(GTK_WINDOW(dialog), title);
			
	button = gtk_button_new_with_label(BUTTON_OK);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area), button, TRUE, TRUE, 0);
	gtk_widget_show(button);
	
	frame = gtk_frame_new(NULL);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), frame, TRUE, TRUE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(frame), 5);
	gtk_widget_show(frame);	
		
	table = gtk_table_new(2 ,1 , FALSE);
	gtk_container_set_border_width(GTK_CONTAINER(table), 5);
	gtk_container_add(GTK_CONTAINER(frame), table);
	gtk_widget_show(table);
	
	label = gtk_label_new(message);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 1, 1, 2);
	gtk_widget_show(label);	
		
	picture = make_pixmapwid(dialog, warning_xpm);
	gtk_table_attach_defaults(GTK_TABLE(table), picture, 0, 1, 0, 1);
	gtk_widget_show(picture);

	gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(dialog));
	gtk_widget_show_all(dialog);
}

void gtk_message_error(gchar *message, gchar *title)
{
	GtkWidget *dialog;
	GtkWidget *label;
	GtkWidget *button;
	GtkWidget *table;
	GtkWidget *picture;
	GtkWidget *frame;
		
	dialog = gtk_dialog_new();

	gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
	gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
	gtk_window_set_title(GTK_WINDOW(dialog), title);
	
	button = gtk_button_new_with_label(BUTTON_OK);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area), button, TRUE, TRUE, 0);
	gtk_widget_show(button);
	
	frame = gtk_frame_new(NULL);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), frame, TRUE, TRUE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(frame), 5);
	gtk_widget_show(frame);	
		
	table = gtk_table_new(2 ,1 , FALSE);
	gtk_container_set_border_width(GTK_CONTAINER(table), 5);
	gtk_container_add(GTK_CONTAINER(frame), table);
	gtk_widget_show(table);
	
	picture = make_pixmapwid(dialog, error_xpm);
	gtk_table_attach_defaults(GTK_TABLE(table), picture, 0, 1, 0, 1);
	gtk_widget_show(picture);

	label = gtk_label_new(message);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 1, 1, 2);
	gtk_widget_show(label);
	
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(dialog));
	gtk_widget_show_all(dialog);
}

void gtk_message_about(gchar *message, gchar *title)
{
	GtkWidget *dialog;
	GtkWidget *label;
	GtkWidget *button;
	GtkWidget *table;
	GtkWidget *picture;
	GtkWidget *frame;
		
	dialog = gtk_dialog_new();

	gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
	gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
	gtk_window_set_title(GTK_WINDOW(dialog), title);
	
	button = gtk_button_new_with_label(BUTTON_OK);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area), button, TRUE, TRUE, 0);
	gtk_widget_show(button);
	
	frame = gtk_frame_new(NULL);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), frame, TRUE, TRUE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(frame), 10);
	gtk_widget_show(frame);	
		
	table = gtk_table_new(2 ,1 , FALSE);
	gtk_container_set_border_width(GTK_CONTAINER(table), 10);
	gtk_container_add(GTK_CONTAINER(frame), table);
	gtk_widget_show(table);
	
	picture = make_pixmapwid(dialog, dabout_xpm);
	gtk_table_attach_defaults(GTK_TABLE(table), picture, 0, 1, 0, 1);
	gtk_widget_show(picture);

	label = gtk_label_new(message);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 1, 1, 2);
	gtk_widget_show(label);
	
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(dialog));
	gtk_widget_show_all(dialog);
}

void gtk_message_whois(gchar *message, gchar *title)
{
	GtkWidget *dialog;
	GtkWidget *label;
	GtkWidget *button;
	GtkWidget *table;
	GtkWidget *picture;
	GtkWidget *frame;
		
	dialog = gtk_dialog_new();

	gtk_window_set_position(GTK_WINDOW(dialog), GTK_WIN_POS_CENTER);
	gtk_window_set_modal(GTK_WINDOW(dialog), TRUE);
	gtk_window_set_title(GTK_WINDOW(dialog), title);
	
	button = gtk_button_new_with_label(BUTTON_OK);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area), button, TRUE, TRUE, 0);
	gtk_widget_show(button);
	
	frame = gtk_frame_new(NULL);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), frame, TRUE, TRUE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(frame), 10);
	gtk_widget_show(frame);	
		
	table = gtk_table_new(2 ,1 , FALSE);
	gtk_container_set_border_width(GTK_CONTAINER(table), 10);
	gtk_container_add(GTK_CONTAINER(frame), table);
	gtk_widget_show(table);
	
	picture = make_pixmapwid(dialog, whois_xpm);
	gtk_table_attach_defaults(GTK_TABLE(table), picture, 0, 1, 0, 1);
	gtk_widget_show(picture);

	label = gtk_label_new(message);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 1, 1, 2);
	gtk_widget_show(label);
	
	gtk_signal_connect_object(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(gtk_widget_destroy), GTK_OBJECT(dialog));
	gtk_widget_show_all(dialog);
}

void login_connect(connect_parm *parm, gboolean newuser)
{
	gint port;
	gchar *ip;	

	ip = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(parm->ip_combo)->entry));
	
	if(GTK_TOGGLE_BUTTON(parm->sb_check)->active)
		port=0;
	else
		port = atoi(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(parm->port_combo)->entry)));

	strcpy((gchar *)parm->sess->username, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->user_entry)));
	strcpy((gchar *)parm->sess->password, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->pw_entry)));
		
	parm->sess->speed = get_speed_nr(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(parm->speed_combo)->entry)));
		
	strcpy((gchar *)parm->sess->directory, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->dd_entry)));
	strcpy((gchar *)parm->sess->email, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->email_entry)));
	
	if((strcmp((gchar *)parm->sess->password, "") != 0) && (strcmp((gchar *)parm->sess->username, "") != 0))
	{
		if(newuser)
		{
			if(strcmp((gchar *)parm->sess->password, gtk_entry_get_text(GTK_ENTRY(parm->pwr_entry))) == 0)
			{
				gtk_label_set_text(GTK_LABEL(parm->sess->login_label), LOGIN_LABEL_STATUS);
				gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 2);
				gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), FALSE);
				gtk_widget_set_sensitive(GTK_WIDGET(parm->ok_button), FALSE);
		
				while(gtk_events_pending())
					gtk_main_iteration();

				if(napster_connect(parm->sess, TRUE, &parm->LOCK, &parm->CANCEL, ip , port))
				{
					gtk_widget_destroy(parm->sess->login_dialog);
				}
				else gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), TRUE);
			}
			else
			{
				gtk_message_warning(MSGBOX_PASSWORD_NOMATCH, MSGBOX_PASSWORD_NOMATCH_TITLE);
			}
		}
		else
		{
			gtk_label_set_text(GTK_LABEL(parm->sess->login_label), LOGIN_LABEL_STATUS);
			gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 2);
			gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), FALSE);
			gtk_widget_set_sensitive(GTK_WIDGET(parm->ok_button), FALSE);
			
			while(gtk_events_pending())
				gtk_main_iteration();

			
			if(napster_connect(parm->sess, FALSE, &parm->LOCK, &parm->CANCEL, ip, port))
			{
				gtk_widget_destroy(parm->sess->login_dialog);
			}
			else gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), TRUE);
		}
	}
	else gtk_message_warning(MSGBOX_MUST_ENTER, MSGBOX_MUST_ENTER_TITLE);
}

void ok_button_func(GtkWidget *widget, gpointer data)
{
	gboolean newuser;

	connect_parm *parm = (connect_parm *)data;
	
	newuser = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(parm->new_user));
	parm->sess->PASSWORD = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(parm->retry_check));
	
	switch (gtk_notebook_get_current_page(GTK_NOTEBOOK(parm->notebook)))
	{
	case 0:
		if(newuser)
		{
			gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 1);
			gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), TRUE);
		}
		else
		{
			login_connect(parm, newuser);
		}
		break;
	case 1:
		login_connect(parm, newuser);
		break;
	}
}

void cancel_button_func(GtkWidget *widget, gpointer data)
{
	connect_parm *parm = (connect_parm *)data;

	if((parm->LOCK) && (gtk_notebook_get_current_page(GTK_NOTEBOOK(parm->notebook)) == 2))
	{
		parm->CANCEL = TRUE;
		gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), TRUE);
		return;
	}
	
	gtk_widget_destroy(parm->sess->login_dialog);
}

void back_button_func(GtkWidget *widget, gpointer data)
{
	gboolean newuser;
	connect_parm *parm = (connect_parm *)data;
	
	newuser = gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(parm->new_user));
	
	switch (gtk_notebook_get_current_page(GTK_NOTEBOOK(parm->notebook)))
	{
	case 2:
		if(!parm->sess->CONNECTED)
		{
			if(newuser)
			{
				gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 1);
				gtk_widget_set_sensitive(GTK_WIDGET(parm->ok_button), TRUE);
			}
			else
			{
				gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 0);
				gtk_widget_set_sensitive(GTK_WIDGET(parm->ok_button), TRUE);
				gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), FALSE);
			}
		}
		break;
	case 1:
		gtk_notebook_set_page(GTK_NOTEBOOK(parm->notebook), 0);
		gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), FALSE);
		break;
	}
}

void dialog_destroy(GtkWidget *widget, gpointer data)
{
	connect_parm *parm = (connect_parm *)data;
	if(parm->LOCK) parm->CANCEL = TRUE; 
	g_free(parm);
}

void connect_dialog(GtkWidget *widget, gpointer data)
{
	GtkWidget *user_label;
	GtkWidget *pw_label;
	GtkWidget *speed_label;
	GtkWidget *dd_label;
	GtkWidget *table;
	GtkWidget *new_table;
	GtkWidget *pm_banner;
	GtkWidget *frame;
	GtkWidget *email_label;
	GtkWidget *pwr_label;
	GtkWidget *alignment;
	GtkWidget *connect_label;
	GtkWidget *port_label;
	GtkWidget *cport_label;
	GtkWidget *pw_frame;
	GtkWidget *sb_frame;
	GtkWidget *general_frame;
	GtkWidget *port_frame;
	GtkWidget *sb_table;
	GtkWidget *port_table;
	GtkWidget *vbox1;
	GtkWidget *vbox2;
	GtkWidget *nsb_radio;
	gchar port[5];
	
	connect_parm *parm;
	GList *linespeed = NULL;
	GList *ports = NULL;
	GList *ips = NULL;
		
	linespeed = g_list_append(linespeed, LINE_SPEED_UNKNOWN);
	linespeed = g_list_append(linespeed, LINE_SPEED_T3);
	linespeed = g_list_append(linespeed, LINE_SPEED_T1);
	linespeed = g_list_append(linespeed, LINE_SPEED_DSL);
	linespeed = g_list_append(linespeed, LINE_SPEED_CABLE);
	linespeed = g_list_append(linespeed, LINE_SPEED_ISDN128);
	linespeed = g_list_append(linespeed, LINE_SPEED_ISDN56);
	linespeed = g_list_append(linespeed, LINE_SPEED_56MODEM);
	linespeed = g_list_append(linespeed, LINE_SPEED_33MODEM);
	linespeed = g_list_append(linespeed, LINE_SPEED_28MODEM);
	linespeed = g_list_append(linespeed, LINE_SPEED_14MODEM);
		
	ips = g_list_append(ips, "208.178.163.61");
	ips = g_list_append(ips, "208.178.175.130");
	ips = g_list_append(ips, "208.178.175.131");
	ips = g_list_append(ips, "208.178.175.132");
	ips = g_list_append(ips, "208.178.175.133");
	ips = g_list_append(ips, "208.178.175.134");
	ips = g_list_append(ips, "208.184.216.193");
	ips = g_list_append(ips, "208.184.216.204");
	ips = g_list_append(ips, "208.184.216.205");
	ips = g_list_append(ips, "208.184.216.206");
	ips = g_list_append(ips, "208.184.216.207");
	ips = g_list_append(ips, "208.184.216.208");
	ips = g_list_append(ips, "208.184.216.209");
	ips = g_list_append(ips, "208.184.216.211");
	ips = g_list_append(ips, "208.184.216.212");
	ips = g_list_append(ips, "208.184.216.213");
	ips = g_list_append(ips, "208.184.216.214");
	ips = g_list_append(ips, "208.184.216.215");
	ips = g_list_append(ips, "208.184.216.217");
	ips = g_list_append(ips, "208.184.216.218");
	ips = g_list_append(ips, "208.184.216.219");
	ips = g_list_append(ips, "208.184.216.220");
	ips = g_list_append(ips, "208.184.216.221");
	ips = g_list_append(ips, "208.49.239.242");
	ips = g_list_append(ips, "208.49.239.7");
	ips = g_list_append(ips, "208.49.239.8");

	ports = g_list_append(ports, "4444");
	ports = g_list_append(ports, "5555");
	ports = g_list_append(ports, "6666");
	ports = g_list_append(ports, "7777");
	ports = g_list_append(ports, "8888");

	parm = (connect_parm *)g_malloc(sizeof(connect_parm));
	parm->sess = (gtk_sess *)data;
	parm->LOCK = FALSE;
	parm->CANCEL = FALSE;
	
	parm->sess->code = parm->sess->toreceive = parm->sess->received = 0;
	
	if(!parm->sess->CONNECTED)
	{
		parm->sess->login_dialog = gtk_dialog_new();

		gtk_window_set_position(GTK_WINDOW(parm->sess->login_dialog), GTK_WIN_POS_CENTER);
		gtk_window_set_modal(GTK_WINDOW(parm->sess->login_dialog), TRUE);
		gtk_window_set_title(GTK_WINDOW(parm->sess->login_dialog), LOGIN_DIALOG_TITLE);
		gtk_signal_connect(GTK_OBJECT(parm->sess->login_dialog), "destroy", GTK_SIGNAL_FUNC(dialog_destroy), parm);

		parm->back_button = gtk_button_new_with_label(BUTTON_BACK);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->sess->login_dialog)->action_area), parm->back_button, TRUE, TRUE, 0);
		gtk_widget_set_sensitive(GTK_WIDGET(parm->back_button), FALSE);
		gtk_widget_show(parm->back_button);
		
		parm->cancel_button = gtk_button_new_with_label(BUTTON_CANCEL);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->sess->login_dialog)->action_area), parm->cancel_button, TRUE, TRUE, 0);
		gtk_widget_show(parm->cancel_button);

		parm->ok_button = gtk_button_new_with_label(BUTTON_NEXT);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->sess->login_dialog)->action_area), parm->ok_button, TRUE, TRUE, 0);
		gtk_widget_show(parm->ok_button);
		
		alignment = gtk_alignment_new(0.5, 0.5 ,0 ,0);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->sess->login_dialog)->vbox), alignment, TRUE, TRUE, 0);
		gtk_widget_show(alignment);
		
		frame = gtk_frame_new(NULL);
		gtk_container_set_border_width(GTK_CONTAINER(frame), 5);		
		gtk_container_add(GTK_CONTAINER(alignment), frame);
		gtk_widget_show(frame);

		pm_banner = make_pixmapwid(parm->sess->login_dialog, banner_xpm);
		gtk_container_add(GTK_CONTAINER(frame), pm_banner);
		gtk_widget_show(pm_banner);

		parm->notebook = gtk_notebook_new();
		gtk_notebook_set_show_border(GTK_NOTEBOOK (parm->notebook), FALSE);
		gtk_notebook_set_show_tabs(GTK_NOTEBOOK (parm->notebook), FALSE);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->sess->login_dialog)->vbox), parm->notebook, TRUE, TRUE, 0);
		gtk_widget_show(parm->notebook);

		vbox1 = gtk_vbox_new(FALSE, 0);
		gtk_notebook_append_page (GTK_NOTEBOOK (parm->notebook), vbox1, NULL);
		gtk_widget_show(vbox1);

		pw_frame = gtk_frame_new(NULL);
		gtk_container_set_border_width(GTK_CONTAINER(pw_frame), 5);
		gtk_box_pack_start(GTK_BOX(vbox1), pw_frame, FALSE, FALSE, 0);
		gtk_widget_show(pw_frame);

		table = gtk_table_new(2 ,3 , FALSE);
		gtk_container_set_border_width(GTK_CONTAINER(table), 10);		
		gtk_container_add(GTK_CONTAINER(pw_frame), table);
		gtk_widget_show(table);

		sb_frame = gtk_frame_new(NULL);
		gtk_container_set_border_width(GTK_CONTAINER(sb_frame), 5);
		gtk_box_pack_start(GTK_BOX(vbox1), sb_frame, FALSE, FALSE, 0);
		gtk_widget_show(sb_frame);

		sb_table = gtk_table_new(2 ,3 , FALSE);
		gtk_container_set_border_width(GTK_CONTAINER(sb_table), 10);		
		gtk_container_add(GTK_CONTAINER(sb_frame), sb_table);
		gtk_widget_show(sb_table);

		user_label = gtk_label_new(LOGIN_LABEL_USERNAME);
		gtk_misc_set_alignment(GTK_MISC(user_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(user_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(table), user_label, 0, 1, 0, 1);
		gtk_widget_show(user_label);
		
		pw_label = gtk_label_new(LOGIN_LABEL_PASSWORD);
		gtk_misc_set_alignment(GTK_MISC(pw_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(pw_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach(GTK_TABLE(table), GTK_WIDGET(pw_label), 0, 1, 1, 2, GTK_SHRINK|GTK_FILL, GTK_SHRINK|GTK_FILL, 0, 0);
		gtk_widget_show(pw_label);

		connect_label = gtk_label_new(LOGIN_LABEL_CONNECT);
		gtk_misc_set_alignment(GTK_MISC(connect_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(connect_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach(GTK_TABLE(sb_table), GTK_WIDGET(connect_label), 0, 1, 1, 2, GTK_SHRINK|GTK_FILL, GTK_SHRINK|GTK_FILL, 0, 0);
		gtk_widget_show(connect_label);

		port_label = gtk_label_new(LOGIN_LABEL_PORT);
		gtk_misc_set_alignment(GTK_MISC(port_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(port_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach(GTK_TABLE(sb_table), GTK_WIDGET(port_label), 0, 1, 2, 3, GTK_SHRINK|GTK_FILL, GTK_SHRINK|GTK_FILL, 0, 0);
		gtk_widget_show(port_label);

		parm->sb_check = gtk_radio_button_new_with_label(NULL, LOGIN_LABEL_SELBEST);
		gtk_table_attach_defaults(GTK_TABLE(sb_table), parm->sb_check, 0, 1, 0, 1);
		gtk_widget_show(parm->sb_check);

		nsb_radio = gtk_radio_button_new_with_label(gtk_radio_button_group (GTK_RADIO_BUTTON (parm->sb_check)), LOGIN_LABEL_NSELBEST);
		gtk_table_attach_defaults(GTK_TABLE(sb_table), nsb_radio, 1, 2, 0, 1);
		gtk_widget_show(nsb_radio);

		parm->new_user = gtk_check_button_new_with_label(LOGIN_LABEL_NEW_USER);
		gtk_table_attach_defaults(GTK_TABLE(table), parm->new_user, 0, 1, 2, 3);
		gtk_widget_show(parm->new_user);
	
		parm->retry_check = gtk_check_button_new_with_label(LOGIN_LABEL_REMEMBER);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->retry_check), parm->sess->PASSWORD);
		gtk_table_attach_defaults(GTK_TABLE(table), parm->retry_check, 1, 2, 2, 3);
		gtk_widget_show(parm->retry_check);

		parm->ip_combo = gtk_combo_new();
		gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(parm->ip_combo)->entry), FALSE);
		gtk_combo_set_popdown_strings(GTK_COMBO(parm->ip_combo), ips);
		gtk_table_attach_defaults(GTK_TABLE(sb_table), parm->ip_combo, 1, 2, 1, 2);
		gtk_widget_show(parm->ip_combo);

		parm->port_combo = gtk_combo_new();
		gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(parm->port_combo)->entry), FALSE);
		gtk_combo_set_popdown_strings(GTK_COMBO(parm->port_combo), ports);
		gtk_table_attach_defaults(GTK_TABLE(sb_table), parm->port_combo, 1, 2, 2, 3);
		gtk_widget_show(parm->port_combo);

		parm->user_entry = gtk_entry_new_with_max_length(19);
		gtk_entry_set_text(GTK_ENTRY(parm->user_entry), parm->sess->username);
		gtk_table_attach_defaults(GTK_TABLE(table), parm->user_entry, 1, 2, 0, 1);
		gtk_widget_show(parm->user_entry);
		
		parm->pw_entry = gtk_entry_new_with_max_length(19);
		gtk_entry_set_visibility(GTK_ENTRY(parm->pw_entry), FALSE);
		gtk_entry_set_text(GTK_ENTRY(parm->pw_entry), parm->sess->password);
		gtk_table_attach_defaults(GTK_TABLE(table), parm->pw_entry, 1, 2, 1, 2);
		gtk_widget_show(parm->pw_entry);		
		
		
		vbox2 = gtk_vbox_new(FALSE, 0);
		gtk_notebook_append_page (GTK_NOTEBOOK (parm->notebook), vbox2, NULL);
		gtk_widget_show(vbox2);
		
		general_frame = gtk_frame_new(NULL);
		gtk_container_set_border_width(GTK_CONTAINER(general_frame), 5);
		gtk_box_pack_start(GTK_BOX(vbox2), general_frame, FALSE, FALSE, 0);
		gtk_widget_show(general_frame);
		
		new_table = gtk_table_new(2 ,4 , FALSE);
		gtk_container_add(GTK_CONTAINER(general_frame), new_table);
		gtk_container_set_border_width(GTK_CONTAINER(new_table), 10);		
		gtk_widget_show(new_table);

		port_frame = gtk_frame_new(NULL);
		gtk_container_set_border_width(GTK_CONTAINER(port_frame), 5);
		gtk_box_pack_start(GTK_BOX(vbox2), port_frame, FALSE, FALSE, 0);
		gtk_widget_show(port_frame);
		
		port_table = gtk_table_new(2 ,2 , FALSE);
		gtk_container_add(GTK_CONTAINER(port_frame), port_table);
		gtk_container_set_border_width(GTK_CONTAINER(port_table), 10);		
		gtk_widget_show(port_table);

		pwr_label = gtk_label_new(LOGIN_LABEL_RETYPE_PASSWORD);
		gtk_misc_set_alignment(GTK_MISC(pwr_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(pwr_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(new_table), pwr_label, 0, 1, 0, 1);
		gtk_widget_show(pwr_label);
		
		email_label = gtk_label_new(LOGIN_LABEL_EMAIL);
		gtk_misc_set_alignment(GTK_MISC(email_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(email_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(new_table), email_label, 0, 1, 1, 2);
		gtk_widget_show(email_label);
		
		parm->pwr_entry = gtk_entry_new_with_max_length(19);
		gtk_entry_set_visibility(GTK_ENTRY(parm->pwr_entry), FALSE);
		gtk_table_attach_defaults(GTK_TABLE(new_table), parm->pwr_entry, 1, 2, 0, 1);
		gtk_widget_show(parm->pwr_entry);

		parm->email_entry = gtk_entry_new_with_max_length(99);
		gtk_entry_set_text(GTK_ENTRY(parm->email_entry), parm->sess->email);
		gtk_table_attach_defaults(GTK_TABLE(new_table), parm->email_entry, 1, 2, 1, 2);
		gtk_widget_show(parm->email_entry);
		
		speed_label = gtk_label_new(LOGIN_LABEL_SPEED);
		gtk_misc_set_alignment(GTK_MISC(speed_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(speed_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(new_table), speed_label, 0, 1, 2, 3);
		gtk_widget_show(speed_label);

		parm->speed_combo = gtk_combo_new();
		gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(parm->speed_combo)->entry), FALSE);
		gtk_combo_set_popdown_strings(GTK_COMBO(parm->speed_combo), linespeed);
		gtk_table_attach_defaults(GTK_TABLE(new_table), parm->speed_combo, 1, 2, 2, 3);
		gtk_widget_show(parm->speed_combo);
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(parm->speed_combo)->entry), get_speed(parm->sess->speed));

		dd_label = gtk_label_new(LOGIN_LABEL_STORE);
		gtk_misc_set_alignment(GTK_MISC(dd_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(dd_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(new_table), dd_label, 0, 1, 3, 4);
		gtk_widget_show(dd_label);
		
		parm->dd_entry = gtk_entry_new_with_max_length(99);
		gtk_entry_set_text(GTK_ENTRY(parm->dd_entry), parm->sess->directory);
		gtk_table_attach_defaults(GTK_TABLE(new_table), parm->dd_entry, 1, 2, 3, 4);
		gtk_widget_show(parm->dd_entry);
		
		parm->firewall_check = gtk_check_button_new_with_label(LOGIN_LABEL_FIREWALL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->firewall_check), parm->sess->FIREWALL);
		gtk_table_attach_defaults(GTK_TABLE(port_table), parm->firewall_check, 1, 2, 0, 1);
		gtk_widget_show(parm->firewall_check);
		
		cport_label = gtk_label_new(LOGIN_LABEL_CPORT);
		gtk_misc_set_alignment(GTK_MISC(cport_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(cport_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(port_table), cport_label, 0, 1, 1, 2);
		gtk_widget_show(cport_label);
		
		parm->port_entry = gtk_entry_new_with_max_length(4);
		sprintf((gchar *)port, "%d", parm->sess->port);
		gtk_entry_set_text(GTK_ENTRY(parm->port_entry), port);
		gtk_table_attach_defaults(GTK_TABLE(port_table), parm->port_entry, 1, 2, 1, 2);
		gtk_widget_show(parm->port_entry);		
		
		parm->sess->login_label = gtk_label_new(LOGIN_LABEL_STATUS);
		gtk_notebook_append_page (GTK_NOTEBOOK (parm->notebook), parm->sess->login_label, NULL);
		
		gtk_signal_connect(GTK_OBJECT(parm->ok_button), "clicked", GTK_SIGNAL_FUNC(ok_button_func), parm);
		gtk_signal_connect(GTK_OBJECT(parm->cancel_button), "clicked", GTK_SIGNAL_FUNC(cancel_button_func), parm);
		gtk_signal_connect(GTK_OBJECT(parm->back_button), "clicked", GTK_SIGNAL_FUNC(back_button_func), parm);
		gtk_widget_show_all(parm->sess->login_dialog);
		if(parm->sess->AUTO_CONNECT && parm->sess->PASSWORD) login_connect(parm, FALSE);
		
		gtk_table_set_row_spacing(GTK_TABLE(table), 0,3);
		gtk_table_set_row_spacing(GTK_TABLE(table), 1,3);
		gtk_table_set_col_spacing(GTK_TABLE(table), 0,3);
		gtk_table_set_row_spacing(GTK_TABLE(sb_table), 0,3);
		gtk_table_set_row_spacing(GTK_TABLE(sb_table), 1,3);
		gtk_table_set_col_spacing(GTK_TABLE(sb_table), 0,3);
		gtk_table_set_row_spacing(GTK_TABLE(new_table), 0,3);
		gtk_table_set_row_spacing(GTK_TABLE(new_table), 1,3);
		gtk_table_set_row_spacing(GTK_TABLE(new_table), 2,3);
		gtk_table_set_col_spacing(GTK_TABLE(new_table), 0, 20);
		gtk_table_set_row_spacing(GTK_TABLE(port_table), 0,3);
		gtk_table_set_col_spacing(GTK_TABLE(port_table), 0, 20);
	}
	else 
	{
		gtk_message_warning(MSGBOX_CONNECTED, MSGBOX_CONNECTED_TITLE);
		g_free(parm);
	}
}

void settings_ok(GtkWidget *widget, gpointer data)
{
	settings_parm *parm = (settings_parm *)data;
	
	parm->sess->speed = get_speed_nr(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(parm->speed_combo)->entry)));

	strcpy((gchar *)parm->sess->email, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->email_entry)));
	strcpy((gchar *)parm->sess->directory, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->storedir_entry)));
	strcpy((gchar *)parm->sess->sharedir, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->sharedir_entry)));
	strcpy((gchar *)parm->sess->exec_player, (gchar *)gtk_entry_get_text(GTK_ENTRY(parm->rundir_entry)));
	
	parm->sess->SHOW_TABS = GTK_TOGGLE_BUTTON(parm->tabs_check)->active;
	parm->sess->SHOW_BYTE = GTK_TOGGLE_BUTTON(parm->bytes_check)->active;
	parm->sess->SHOW_DHMS = GTK_TOGGLE_BUTTON(parm->dhms_check)->active;
	parm->sess->SWITCH_TRANSFER = GTK_TOGGLE_BUTTON(parm->switch_check)->active;
	parm->sess->AUTO_CONNECT = GTK_TOGGLE_BUTTON(parm->auto_check)->active;
	parm->sess->FIREWALL = GTK_TOGGLE_BUTTON(parm->firewall_check)->active;
	
	parm->sess->timeout = atoi((gchar *)gtk_entry_get_text(GTK_ENTRY(parm->timeout_entry)));
	parm->sess->maxdls = atoi((gchar *)gtk_entry_get_text(GTK_ENTRY(parm->maxdls_entry)));
	parm->sess->maxuls = atoi((gchar *)gtk_entry_get_text(GTK_ENTRY(parm->maxuls_entry)));
	parm->sess->port = atoi((gchar *)gtk_entry_get_text(GTK_ENTRY(parm->port_entry)));

	gtk_notebook_set_show_tabs(GTK_NOTEBOOK (parm->sess->page), parm->sess->SHOW_TABS);
		
	gtk_widget_destroy(parm->dialog);
	g_free(parm);
}

void settings_cancel(GtkWidget *widget, gpointer data)
{
	settings_parm *parm = (settings_parm *)data;
	gtk_widget_destroy(parm->dialog);
	g_free(parm);
}

void settings_dialog(GtkWidget *widget, gpointer data)
{
		GtkWidget *ok_button;
		GtkWidget *cancel_button;
		GtkWidget *general_table;
		GtkWidget *connection_table;
		GtkWidget *dir_table;
		GtkWidget *lf_table;
		GtkWidget *label1;
		GtkWidget *label2;
		GtkWidget *label3;
		GtkWidget *label4;
		GtkWidget *info_label;
		GtkWidget *email_label;
		GtkWidget *speed_label;
		GtkWidget *storedir_label;
		GtkWidget *sharedir_label;
		GtkWidget *rundir_label;
		GtkWidget *timeout_label;
		GtkWidget *maxdl_label;
		GtkWidget *maxul_label;
		GtkWidget *notebook;
		GtkWidget *port_label;
		settings_parm *parm;
		gchar timeout[4];
		gchar maxdls[3];
		gchar maxuls[3];
		gchar port[5];
		GList *linespeed = NULL;
		GtkWidget *vbox1;
		GtkWidget *vbox2;
		GtkWidget *vbox3;
		GtkWidget *vbox4;
		gtk_sess *sess = (gtk_sess *)data;
		
		linespeed = g_list_append(linespeed, LINE_SPEED_UNKNOWN);
		linespeed = g_list_append(linespeed, LINE_SPEED_T3);
		linespeed = g_list_append(linespeed, LINE_SPEED_T1);
		linespeed = g_list_append(linespeed, LINE_SPEED_DSL);
		linespeed = g_list_append(linespeed, LINE_SPEED_CABLE);
		linespeed = g_list_append(linespeed, LINE_SPEED_ISDN128);
		linespeed = g_list_append(linespeed, LINE_SPEED_ISDN56);
		linespeed = g_list_append(linespeed, LINE_SPEED_56MODEM);
		linespeed = g_list_append(linespeed, LINE_SPEED_33MODEM);
		linespeed = g_list_append(linespeed, LINE_SPEED_28MODEM);
		linespeed = g_list_append(linespeed, LINE_SPEED_14MODEM);

		parm = (settings_parm *)g_malloc(sizeof(settings_parm));
		parm->sess = sess;
		parm->dialog = gtk_dialog_new();
		
		notebook = gtk_notebook_new();		
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->dialog)->vbox), notebook, TRUE, TRUE, 0);
		gtk_widget_show(notebook);
		
		gtk_window_set_position(GTK_WINDOW(parm->dialog), GTK_WIN_POS_CENTER);
		gtk_window_set_modal(GTK_WINDOW(parm->dialog), TRUE);
		gtk_window_set_title(GTK_WINDOW(parm->dialog), SETTINGS_DIALOG_TITLE);

		ok_button = gtk_button_new_with_label(BUTTON_OK);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->dialog)->action_area), ok_button, TRUE, TRUE, 0);
		gtk_widget_show(ok_button);
		
		cancel_button = gtk_button_new_with_label(BUTTON_CANCEL);
		gtk_box_pack_start (GTK_BOX (GTK_DIALOG (parm->dialog)->action_area), cancel_button, TRUE, TRUE, 0);
		gtk_widget_show(cancel_button);
		
		vbox1 = gtk_vbox_new(FALSE, 0);
		label1 = gtk_label_new(SETTINGS_FRAME_GENERAL);
		gtk_notebook_append_page (GTK_NOTEBOOK (notebook), vbox1, label1);
		gtk_widget_show(vbox1);

		vbox2 = gtk_vbox_new(FALSE, 0);
		label2 = gtk_label_new(SETTINGS_FRAME_DIR);
		gtk_notebook_append_page (GTK_NOTEBOOK (notebook), vbox2, label2);
		gtk_widget_show(vbox2);

		vbox3 = gtk_vbox_new(FALSE, 0);
		label3 = gtk_label_new(SETTINGS_FRAME_LOOK_FEEL);
		gtk_notebook_append_page (GTK_NOTEBOOK (notebook), vbox3, label3);
		gtk_widget_show(vbox3);
		
		vbox4 = gtk_vbox_new(FALSE, 0);
		label4 = gtk_label_new(SETTINGS_FRAME_CONNECTION);
		gtk_notebook_append_page (GTK_NOTEBOOK (notebook), vbox4, label4);
		gtk_widget_show(vbox4);
		
		general_table = gtk_table_new(2 ,4 , FALSE);
		gtk_container_set_border_width(GTK_CONTAINER(general_table), 10);		
		gtk_box_pack_start(GTK_BOX(vbox1), general_table, FALSE, FALSE, 0);
		gtk_widget_show(general_table);
		
		dir_table = gtk_table_new(2 ,3 , FALSE);
		gtk_container_set_border_width(GTK_CONTAINER(dir_table), 10);		
		gtk_table_set_row_spacings(GTK_TABLE(dir_table), 5);
		gtk_table_set_col_spacing(GTK_TABLE(dir_table), 0, 20);
		gtk_box_pack_start(GTK_BOX(vbox2), dir_table, FALSE, FALSE, 0);
		gtk_widget_show(dir_table);
		
		lf_table = gtk_table_new(2 ,5 , FALSE);
		gtk_container_set_border_width(GTK_CONTAINER(lf_table), 10);
		gtk_box_pack_start(GTK_BOX(vbox3), lf_table, FALSE, FALSE, 0);
		gtk_widget_show(lf_table);
		
		connection_table = gtk_table_new(2 ,4 , FALSE);
		gtk_container_set_border_width(GTK_CONTAINER(connection_table), 10);		
		gtk_box_pack_start(GTK_BOX(vbox4), connection_table, FALSE, FALSE, 0);
		gtk_widget_show(connection_table);
		
		speed_label = gtk_label_new(SETTINGS_LABEL_SPEED);
		gtk_misc_set_alignment(GTK_MISC(speed_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(speed_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(connection_table), speed_label, 0, 1, 0, 1);
		gtk_widget_show(speed_label);
		
		email_label = gtk_label_new(SETTINGS_LABEL_EMAIL);
		gtk_misc_set_alignment(GTK_MISC(email_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(email_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(general_table), email_label, 0, 1, 0, 1);
		gtk_widget_show(email_label);
		
		storedir_label = gtk_label_new(SETTINGS_LABEL_STORE);
		gtk_misc_set_alignment(GTK_MISC(storedir_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(storedir_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(dir_table), storedir_label, 0, 1, 0, 1);
		gtk_widget_show(storedir_label);
		
		sharedir_label = gtk_label_new(SETTINGS_LABEL_SHARE);
		gtk_misc_set_alignment(GTK_MISC(sharedir_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(sharedir_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(dir_table), sharedir_label, 0, 1, 1, 2);
		gtk_widget_show(sharedir_label);
		
		rundir_label = gtk_label_new(SETTINGS_LABEL_RUN_COMMAND);
		gtk_misc_set_alignment(GTK_MISC(rundir_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(rundir_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(dir_table), rundir_label, 0, 1, 2, 3);
		gtk_widget_show(rundir_label);
		
		timeout_label = gtk_label_new(SETTINGS_LABEL_TIMEOUT);
		gtk_misc_set_alignment(GTK_MISC(timeout_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(timeout_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(general_table), timeout_label, 0, 1, 1, 2);
		gtk_widget_show(timeout_label);

		maxdl_label = gtk_label_new(SETTINGS_LABEL_MAXDL);
		gtk_misc_set_alignment(GTK_MISC(maxdl_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(maxdl_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(general_table), maxdl_label, 0, 1, 2, 3);
		gtk_widget_show(maxdl_label);

		maxul_label = gtk_label_new(SETTINGS_LABEL_MAXUL);
		gtk_misc_set_alignment(GTK_MISC(maxul_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(maxul_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(general_table), maxul_label, 0, 1, 3, 4);
		gtk_widget_show(maxul_label);
		
		port_label = gtk_label_new(SETTINGS_LABEL_PORT);
		gtk_misc_set_alignment(GTK_MISC(port_label), 0, 0.5);
		gtk_label_set_justify(GTK_LABEL(port_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(connection_table), port_label, 0, 1, 1, 2);
		gtk_widget_show(port_label);
		
		info_label = gtk_label_new(SETTINGS_LABEL_INFO);
		gtk_label_set_justify(GTK_LABEL(info_label), GTK_JUSTIFY_LEFT);
		gtk_table_attach_defaults(GTK_TABLE(connection_table), info_label, 0, 2, 3, 4);
		gtk_widget_show(info_label);

		parm->speed_combo = gtk_combo_new();
		gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(parm->speed_combo)->entry), FALSE);
		gtk_combo_set_popdown_strings(GTK_COMBO(parm->speed_combo), linespeed);
		gtk_table_attach_defaults(GTK_TABLE(connection_table), parm->speed_combo, 1, 2, 0, 1);
		gtk_widget_show(parm->speed_combo);
		gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(parm->speed_combo)->entry), get_speed(sess->speed));

		parm->email_entry = gtk_entry_new_with_max_length(99);
		gtk_entry_set_text(GTK_ENTRY(parm->email_entry), sess->email);
		gtk_table_attach_defaults(GTK_TABLE(general_table), parm->email_entry, 1, 2, 0, 1);
		gtk_widget_show(parm->email_entry);
		
		parm->tabs_check = gtk_check_button_new_with_label(SETTINGS_LABEL_TAB);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->tabs_check), sess->SHOW_TABS);
		gtk_table_attach_defaults(GTK_TABLE(lf_table), parm->tabs_check, 0, 2, 0, 1);
		gtk_widget_show(parm->tabs_check);

		parm->bytes_check = gtk_check_button_new_with_label(SETTINGS_LABEL_FILESIZE);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->bytes_check), sess->SHOW_BYTE);
		gtk_table_attach_defaults(GTK_TABLE(lf_table), parm->bytes_check, 0, 2, 1, 2);
		gtk_widget_show(parm->bytes_check);
		
		parm->dhms_check = gtk_check_button_new_with_label(SETTINGS_LABEL_TIME);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->dhms_check), sess->SHOW_DHMS);
		gtk_table_attach_defaults(GTK_TABLE(lf_table), parm->dhms_check, 0, 2, 2, 3);
		gtk_widget_show(parm->dhms_check);
		
		parm->switch_check = gtk_check_button_new_with_label(SETTINGS_LABEL_SWITCH);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->switch_check), sess->SWITCH_TRANSFER);
		gtk_table_attach_defaults(GTK_TABLE(lf_table), parm->switch_check, 0, 2, 3, 4);
		gtk_widget_show(parm->switch_check);
		
		parm->auto_check = gtk_check_button_new_with_label(SETTINGS_LABEL_AUTO);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->auto_check), sess->AUTO_CONNECT);
		gtk_table_attach_defaults(GTK_TABLE(lf_table), parm->auto_check, 0, 2, 4, 5);
		gtk_widget_show(parm->auto_check);
		
		parm->firewall_check = gtk_check_button_new_with_label(SETTINGS_LABEL_FIREWALL);
		gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(parm->firewall_check), sess->FIREWALL);
		gtk_table_attach_defaults(GTK_TABLE(connection_table), parm->firewall_check, 1, 2, 2, 3);
		gtk_widget_show(parm->firewall_check);

		parm->storedir_entry = gtk_entry_new_with_max_length(99);
		gtk_entry_set_text(GTK_ENTRY(parm->storedir_entry), sess->directory);
		gtk_table_attach_defaults(GTK_TABLE(dir_table), parm->storedir_entry, 1, 2, 0, 1);
		gtk_widget_show(parm->storedir_entry);
		
		parm->port_entry = gtk_entry_new_with_max_length(4);
	  	sprintf((gchar *)port, "%d", sess->port);
		gtk_entry_set_text(GTK_ENTRY(parm->port_entry), port);
		gtk_table_attach_defaults(GTK_TABLE(connection_table), parm->port_entry, 1, 2, 1, 2);
		gtk_widget_show(parm->port_entry);
	
		parm->sharedir_entry = gtk_entry_new_with_max_length(99);
		gtk_entry_set_text(GTK_ENTRY(parm->sharedir_entry), sess->sharedir);
		gtk_table_attach_defaults(GTK_TABLE(dir_table), parm->sharedir_entry, 1, 2, 1, 2);
		gtk_widget_show(parm->sharedir_entry);
		
		parm->rundir_entry = gtk_entry_new_with_max_length(149);
		gtk_entry_set_text(GTK_ENTRY(parm->rundir_entry), sess->exec_player);
		gtk_table_attach_defaults(GTK_TABLE(dir_table), parm->rundir_entry, 1, 2, 2, 3);
		gtk_widget_show(parm->rundir_entry);
		
		parm->timeout_entry = gtk_entry_new_with_max_length(3);
	  	sprintf((gchar *)timeout, "%d", sess->timeout);
		gtk_entry_set_text(GTK_ENTRY(parm->timeout_entry), (gchar *)timeout);
		gtk_table_attach_defaults(GTK_TABLE(general_table), parm->timeout_entry, 1, 2, 1, 2);
		gtk_widget_show(parm->timeout_entry);
		
		parm->maxdls_entry = gtk_entry_new_with_max_length(2);
	  	sprintf((gchar *)maxdls, "%d", sess->maxdls);
		gtk_entry_set_text(GTK_ENTRY(parm->maxdls_entry), (gchar *)maxdls);
		gtk_table_attach_defaults(GTK_TABLE(general_table), parm->maxdls_entry, 1, 2, 2, 3);
		gtk_widget_show(parm->maxdls_entry);

		parm->maxuls_entry = gtk_entry_new_with_max_length(2);
	  	sprintf((gchar *)maxuls, "%d", sess->maxuls);
		gtk_entry_set_text(GTK_ENTRY(parm->maxuls_entry), (gchar *)maxuls);
		gtk_table_attach_defaults(GTK_TABLE(general_table), parm->maxuls_entry, 1, 2, 3, 4);
		gtk_widget_show(parm->maxuls_entry);
		
		gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(settings_ok), parm);
		gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(settings_cancel), parm);

		gtk_widget_show_all(parm->dialog);
	   
		gtk_table_set_row_spacing(GTK_TABLE(general_table), 0,3);
		gtk_table_set_row_spacing(GTK_TABLE(general_table), 1,3);
		gtk_table_set_row_spacing(GTK_TABLE(general_table), 2,3);
		gtk_table_set_col_spacing(GTK_TABLE(general_table), 0,5);
		gtk_table_set_row_spacing(GTK_TABLE(dir_table), 0,3);
		gtk_table_set_row_spacing(GTK_TABLE(dir_table), 1,3);
		gtk_table_set_col_spacing(GTK_TABLE(dir_table), 0,5);
		gtk_table_set_row_spacing(GTK_TABLE(connection_table), 0,3);
		gtk_table_set_row_spacing(GTK_TABLE(connection_table), 1,3);
		gtk_table_set_row_spacing(GTK_TABLE(connection_table), 2,3);
		gtk_table_set_col_spacing(GTK_TABLE(connection_table), 0,5);
}

void resume_cancel(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	sess->resume.OPEN = FALSE;
	gtk_clist_clear(GTK_CLIST(sess->resume.clist));
	gtk_widget_destroy(sess->resume.dialog);
}

void destroy_resume_dialog(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	sess->resume.OPEN = FALSE;
}

void resume_connect(GtkWidget *widget,  GdkEventButton *event, gpointer data)
{
	gint row, column, dlrow;
	gchar *command;
	gtk_dl_sess *dlsess = (gtk_dl_sess *)data;
	gchar *filename;
	gchar *user;
	
	if(event->button != 1) return;
	if(event->type != GDK_2BUTTON_PRESS) return;
	
	gtk_clist_get_selection_info(GTK_CLIST(dlsess->sess->resume.clist), event->x , event->y, &row, &column);
	filename = gtk_clist_get_row_data(GTK_CLIST(dlsess->sess->resume.clist), row);
	dlrow = gtk_clist_find_row_from_data(GTK_CLIST(dlsess->sess->transfer_list), dlsess);
	gtk_clist_get_text(GTK_CLIST(dlsess->sess->resume.clist), row, 1, &user);
	dlsess->filename = (gchar *)g_realloc(dlsess->filename, strlen(filename)+1);
	strcpy(dlsess->filename, filename);
	
	if(!must_be_queued(dlsess->sess))
	{
		command = (gchar *)g_malloc(strlen(filename) + strlen(user) + 5);
		sprintf(command, "%s \"%s\"", user, filename);

		if(!send_string(dlsess->sess, command, 203))
		{
			gtk_clist_set_text(GTK_CLIST(dlsess->sess->transfer_list), dlrow, 5, TRANSFER_STATUS_ERROR);
			gtk_statusbar_push(GTK_STATUSBAR(dlsess->sess->statusbar), 1, STATUSBAR_GET_INFO);
		}
		else dlsess->CONNECTING = TRUE;
		g_free(command);
	}
	else
	{
		gtk_clist_set_text(GTK_CLIST(dlsess->sess->transfer_list), dlrow, 5, TRANSFER_STATUS_QUEUED);
		dlsess->sess->queue = g_list_append(dlsess->sess->queue, (gpointer)dlsess);
	}
	gtk_clist_set_text(GTK_CLIST(dlsess->sess->transfer_list), dlrow, 3, user);
}

void resume_dialog(gtk_dl_sess *dlsess)
{
	GtkWidget *scrolled_window;
	GtkWidget *cancel;
	gchar *command;
	gchar *ltitles[4] = {COLUMN_FILENAME, COLUMN_USER, COLUMN_LINESPEED, COLUMN_FILESIZE};

  	if(dlsess == NULL)
	{ 
		g_warning("Received a null pointer when resuming"); 
		return;
	}
	if((dlsess->CONNECTING) || (dlsess->ACTIVE)) return;
	if(strcasecmp((gchar *)dlsess->md5, "") == 0) return;
	if(dlsess->size <= 0) return;
	
	dlsess->sess->resume.OPEN = TRUE;	
	dlsess->sess->resume.dialog = gtk_dialog_new();
	
	gtk_window_set_position(GTK_WINDOW(dlsess->sess->resume.dialog), GTK_WIN_POS_CENTER);
	gtk_window_set_modal(GTK_WINDOW(dlsess->sess->resume.dialog), FALSE);
	gtk_window_set_title(GTK_WINDOW(dlsess->sess->resume.dialog), RESUME_DIALOG_TITLE);
	gtk_window_set_default_size(GTK_WINDOW(dlsess->sess->resume.dialog), 480, 200);
	gtk_signal_connect(GTK_OBJECT(dlsess->sess->resume.dialog), "destroy", GTK_SIGNAL_FUNC(destroy_resume_dialog), dlsess->sess);

	dlsess->sess->resume.status = gtk_label_new(STATUS_LABEL_WAIT);
	gtk_box_pack_start(GTK_BOX (GTK_DIALOG (dlsess->sess->resume.dialog)->vbox), dlsess->sess->resume.status, FALSE, FALSE, 0);
	gtk_widget_show(dlsess->sess->resume.status);
	dlsess->sess->resume.clist = gtk_clist_new_with_titles(4, ltitles);
  	gtk_clist_set_shadow_type(GTK_CLIST(dlsess->sess->resume.clist), GTK_SHADOW_OUT);		
	gtk_clist_set_column_width(GTK_CLIST(dlsess->sess->resume.clist), 0, 260);
	gtk_clist_set_column_width(GTK_CLIST(dlsess->sess->resume.clist), 1, 75);
	gtk_clist_set_column_width(GTK_CLIST(dlsess->sess->resume.clist), 2, 50);
	gtk_signal_connect(GTK_OBJECT(dlsess->sess->resume.dialog), "button_press_event", GTK_SIGNAL_FUNC(resume_connect), dlsess);
	scrolled_window = gtk_scrolled_window_new (NULL, NULL);
   	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	gtk_box_pack_start(GTK_BOX (GTK_DIALOG (dlsess->sess->resume.dialog)->vbox), scrolled_window, TRUE, TRUE, 0);
   	gtk_widget_show(scrolled_window);
   	gtk_widget_show(dlsess->sess->resume.clist);
   
   	gtk_container_add (GTK_CONTAINER (scrolled_window), dlsess->sess->resume.clist);
	
	cancel = gtk_button_new_with_label(BUTTON_CANCEL);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dlsess->sess->resume.dialog)->action_area), cancel, TRUE, TRUE, 0);
	gtk_signal_connect(GTK_OBJECT(cancel), "clicked", GTK_SIGNAL_FUNC(resume_cancel), dlsess->sess);
	gtk_widget_show(cancel);
	
	gtk_widget_show_all(dlsess->sess->resume.dialog);
	
	command = g_malloc(strlen(dlsess->md5) + 15);
	sprintf(command, "%s %.0f", dlsess->md5, (double)dlsess->size);
	send_string(dlsess->sess, command, 215);
	dlsess->sess->resume.RECEIVING = TRUE;
	dlsess->sess->resume.OPEN = TRUE;
	g_free(command);
}
