/* GTK Napster-0.301
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _NDIALOG_H_
#define _NDIALOG_H_

#include "xpm/banner.xpm"
#include "xpm/warning.xpm"
#include "xpm/error.xpm"
#include "xpm/dabout.xpm"
#include "xpm/whois.xpm"

#define DEFAULT_EMAIL 								"anon@napster.com"
#define DEFAULT_PLAYER 								"xmms %s"
#define RC_FILENAME 									".gtknap"

/* 1=Filename */
#define WARNING_FILE_NOT_FOUND 				"File %s not found, will be created!"
#define WARNING_CANNOT_WRITE 					"Can't write to %s!"

#define BUTTON_OK 										"OK"
#define BUTTON_BACK 									"Back"
#define BUTTON_CANCEL 								"Cancel"
#define BUTTON_NEXT 									"Next"

#define STATUSBAR_GET_INFO 						"Error: While sending get info."
#define TRANSFER_STATUS_ERROR 				"Error..."
#define TRANSFER_STATUS_QUEUED 				"Queued..."


#define MSGBOX_PASSWORD_NOMATCH 			"The passwords you entered, does not match!"
#define MSGBOX_PASSWORD_NOMATCH_TITLE 	"Password Error!"

#define MSGBOX_MUST_ENTER 						"You must enter a username and password!"
#define MSGBOX_MUST_ENTER_TITLE 			"Login error!"

#define MSGBOX_CONNECTED 							"You are already connected to the server!"
#define MSGBOX_CONNECTED_TITLE 				"Can't do that!"

#define LOGIN_DIALOG_TITLE 						"Connection Dialog"
#define LOGIN_LABEL_USERNAME 					"Username:"
#define LOGIN_LABEL_PASSWORD 					"Password:"
#define LOGIN_LABEL_NEW_USER 					"New User"
#define LOGIN_LABEL_REMEMBER					"Remember password"
#define LOGIN_LABEL_RETYPE_PASSWORD 		"Retype password:"
#define LOGIN_LABEL_EMAIL 						"E-Mail:"
#define LOGIN_LABEL_SPEED 						"Line speed:"
#define LOGIN_LABEL_STORE 						"Store files in:"
#define LOGIN_LABEL_STATUS 						"Connecting: Finding best server..."
#define LOGIN_LABEL_SELBEST						"Auto get best server"
#define LOGIN_LABEL_PORT							"Port:"
#define LOGIN_LABEL_CONNECT						"Server:"
#define LOGIN_LABEL_NSELBEST					"Select server manualy"
#define LOGIN_LABEL_FIREWALL					"I'm behind a firewall"
#define LOGIN_LABEL_CPORT							"Listen on port:"

#define SETTINGS_LABEL_INFO						"Reconnect after changing the port number."
#define SETTINGS_DIALOG_TITLE 				"GTK-Napster settings"
#define SETTINGS_FRAME_GENERAL 				"General"
#define SETTINGS_FRAME_DIR 						"Directories"
#define SETTINGS_FRAME_LOOK_FEEL 			"Look & Feel"
#define SETTINGS_LABEL_SPEED 					"Line speed:"
#define SETTINGS_LABEL_MAXUL 					"Maximum number of uploads"
#define SETTINGS_LABEL_MAXDL 					"Maximum number of downloads"
#define SETTINGS_LABEL_EMAIL 					"E-Mail:"
#define SETTINGS_LABEL_STORE 					"Store files in:"
#define SETTINGS_LABEL_TIMEOUT				"Timeout after (seconds):"
#define SETTINGS_LABEL_SHARE 					"Share file:"
#define SETTINGS_LABEL_SWITCH					"Switch to transfer when downloading files"
#define SETTINGS_LABEL_AUTO						"Autoconnect when starting program"
#define SETTINGS_LABEL_RUN_COMMAND		"Player:"
#define SETTINGS_LABEL_TAB 						"Show tabs on pages"
#define SETTINGS_LABEL_FILESIZE 			"Show filesize as MB\\KB\\Byte"
#define SETTINGS_LABEL_TIME 					"Show time as xxd xxh xxm xxs"
#define SETTINGS_LABEL_FIREWALL				"I'm behind a firewall"
#define SETTINGS_FRAME_CONNECTION			"Connection"
#define SETTINGS_LABEL_PORT						"Listen for connections on port:  "

#define RESUME_DIALOG_TITLE 					"GTK-Napster resume"
#define STATUS_LABEL_WAIT							"Please wait..."

typedef struct connect_parm
{
	gtk_sess *sess;
	GtkWidget *user_entry;
	GtkWidget *port_combo;
	GtkWidget *ip_combo;
	GtkWidget *pw_entry;
	GtkWidget *speed_combo;
	GtkWidget *dd_entry;
	GtkWidget *email_entry;
	GtkWidget *pwr_entry;
	GtkWidget *retry_check;
	GtkWidget *sb_check;
	GtkWidget *notebook;
	GtkWidget *new_user;
	GtkWidget *ok_button;
	GtkWidget *back_button;
	GtkWidget *cancel_button;
	GtkWidget *firewall_check;
	GtkWidget *port_entry;
	gboolean LOCK;
	gboolean CANCEL;
} connect_parm;

typedef struct settings_parm
{
	gtk_sess *sess;
	GtkWidget *email_entry;
	GtkWidget *speed_combo;
	GtkWidget *storedir_entry;
	GtkWidget *sharedir_entry;
	GtkWidget *rundir_entry;
	GtkWidget *tabs_check;
	GtkWidget *bytes_check;
	GtkWidget *dhms_check;
	GtkWidget *switch_check;
	GtkWidget *auto_check;
	GtkWidget *timeout_entry;
	GtkWidget *dialog;
	GtkWidget *firewall_check;
	GtkWidget *port_entry;
	GtkWidget *maxdls_entry;
	GtkWidget *maxuls_entry;
} settings_parm;

void WriteSharedFile(gtk_sess *sess);
void ReadRCFile(gtk_sess *sess);
void get_hotlist_users(gtk_sess *sess, FILE *rcfile);
void WriteRCFile(gtk_sess *sess);
void gtk_message_warning(gchar *message, gchar *title);
void gtk_message_error(gchar *message, gchar *title);
void gtk_message_about(gchar *message, gchar *title);
void gtk_message_whois(gchar *message, gchar *title);
void login_connect(connect_parm *parm, gboolean newuser);
void ok_button_func(GtkWidget *widget, gpointer data);
void cancel_button_func(GtkWidget *widget, gpointer data);
void back_button_func(GtkWidget *widget, gpointer data);
void dialog_destroy(GtkWidget *widget, gpointer data);
void connect_dialog(GtkWidget *widget, gpointer data);
void settings_ok(GtkWidget *widget, gpointer data);
void settings_cancel(GtkWidget *widget, gpointer data);
void settings_dialog(GtkWidget *widget, gpointer data);
void resume_dialog(gtk_dl_sess *dlsess);
void resume_cancel(GtkWidget *widget, gpointer data);
void destroy_resume_list(gpointer data);
void destroy_resume_dialog(GtkWidget *widget, gpointer data);

#endif