/* GTK Napster-0.301
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <string.h>
#include <stdlib.h>

#include "common.h"
#include "nhotlist.h"
#include "sort.h"

void command_hotlist_nofiles(gtk_sess *sess, gchar *instr)
{
	gtk_clist_set_text(GTK_CLIST(sess->hotlist.clist), 0, 0, HL_CLIST_FINISHED);
}

void hl_cancel_func(GtkWidget *widget, gpointer data)
{
	gtk_hl_sess *hlsess = (gtk_hl_sess *)data;
	gtk_widget_destroy(hlsess->dialog);
	g_free(hlsess);
}

void hl_send_logon_request(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	GdkPixmap *pixm;
	GdkBitmap *bitm;
	gint spacing;
	gint row = 0;
	gchar *username;

	while(gtk_clist_get_pixtext(GTK_CLIST(sess->hotlist.onlinelist), row, 0, &username, (guint8*)&spacing, &pixm, &bitm) != 0)
	{
		gtk_clist_append(GTK_CLIST(sess->hotlist.offlinelist), &username);
		gtk_clist_remove(GTK_CLIST(sess->hotlist.onlinelist), row);
		row++;
	}
	
	row = 0;
	
	while(gtk_clist_get_text(GTK_CLIST(sess->hotlist.offlinelist), row, 0, &username) != 0)
	{
		if(!send_string(sess, username, 208)) return;
		row++;
	}
}

void hl_ok_func(GtkWidget *widget, gpointer data)
{
	gtk_hl_sess *hlsess = (gtk_hl_sess *)data;

	add_user_to_hotlist(hlsess->sess, gtk_entry_get_text(GTK_ENTRY(hlsess->entry)));

	gtk_widget_destroy(hlsess->dialog);
	g_free(hlsess);
}

void hl_ok_remove_func(GtkWidget *widget, gpointer data)
{
	gtk_hl_sess *hlsess = (gtk_hl_sess *)data;
	gtk_sess *sess = hlsess->sess;
	GdkPixmap *pixm;
	GdkBitmap *bitm;
	gint spacing;
	gint row = 0;
	gchar *username;
	gchar *toberemoved;
	
	toberemoved = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(hlsess->entry)->entry));

	if(!send_string(sess, toberemoved, 303)) return;

	while(gtk_clist_get_pixtext(GTK_CLIST(sess->hotlist.onlinelist), row, 0, &username, (guint8*)&spacing, &pixm, &bitm) != 0)
	{
		if(strcmp(username, toberemoved) == 0) gtk_clist_remove(GTK_CLIST(sess->hotlist.onlinelist), row);
		row++;
	}
	
	row = 0;
	
	while(gtk_clist_get_text(GTK_CLIST(sess->hotlist.offlinelist), row, 0, &username) != 0)
	{
		if(strcmp(username, toberemoved) == 0) gtk_clist_remove(GTK_CLIST(sess->hotlist.offlinelist), row);
		row++;
	}

	gtk_widget_destroy(hlsess->dialog);
	g_free(hlsess);
}

void add_hl_dialog(GtkWidget *widget, gpointer data)
{
	GtkWidget *label;
	GtkWidget *ok_button;
	GtkWidget *cancel_button;
	GtkWidget *table;
	gtk_sess *sess = (gtk_sess *)data;
	gtk_hl_sess *hlsess;
	
	hlsess = (gtk_hl_sess*)g_malloc(sizeof(gtk_hl_sess));
	hlsess->sess = sess;
		
	hlsess->dialog = gtk_dialog_new();

	gtk_window_set_position(GTK_WINDOW(hlsess->dialog), GTK_WIN_POS_CENTER);
	gtk_window_set_modal(GTK_WINDOW(hlsess->dialog), TRUE);
	gtk_window_set_title(GTK_WINDOW(hlsess->dialog), HL_DIALOG_TITLE);
	
	ok_button = gtk_button_new_with_label(HL_BUTTON_OK);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (hlsess->dialog)->action_area), ok_button, TRUE, TRUE, 0);
	gtk_widget_show(ok_button);
	
	cancel_button = gtk_button_new_with_label(HL_BUTTON_CANCEL);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (hlsess->dialog)->action_area), cancel_button, TRUE, TRUE, 0);
	gtk_widget_show(cancel_button);
	
	table = gtk_table_new(1 ,2 , FALSE);
	gtk_container_set_border_width(GTK_CONTAINER(table), 10);		
	gtk_table_set_col_spacing(GTK_TABLE(table),0, 10);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (hlsess->dialog)->vbox), table, TRUE, TRUE, 0);
	gtk_widget_show(table);
	
	label = gtk_label_new(HL_LABEL_ADD_USER);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 1, 0, 1);
	gtk_widget_show(label);
	
	hlsess->entry = gtk_entry_new_with_max_length(19);
	gtk_table_attach_defaults(GTK_TABLE(table), hlsess->entry, 1, 2, 0, 1);
	gtk_widget_show(hlsess->entry);

	gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(hl_ok_func), hlsess);
	gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(hl_cancel_func), hlsess);
	gtk_widget_show_all(hlsess->dialog);
}


void remove_hl_dialog(GtkWidget *widget, gpointer data)
{
	GtkWidget *label;
	GtkWidget *ok_button;
	GtkWidget *cancel_button;
	GtkWidget *table;
	gtk_sess *sess = (gtk_sess *)data;
	gtk_hl_sess *hlsess;
	GList *users = NULL;
	GdkPixmap *pixm;
	GdkBitmap *bitm;
	gint spacing;
	gint row = 0;
	gchar *username;
	
	while(gtk_clist_get_pixtext(GTK_CLIST(sess->hotlist.onlinelist), row, 0, &username, (guint8*)&spacing, &pixm, &bitm) != 0)
	{
		users = g_list_append(users, username);
		row++;
	}
	
	row = 0;
	
	while(gtk_clist_get_text(GTK_CLIST(sess->hotlist.offlinelist), row, 0, &username) != 0)
	{
		users = g_list_append(users, username);
		row++;
	}
	
	hlsess = (gtk_hl_sess*)g_malloc(sizeof(gtk_hl_sess));
	hlsess->sess = sess;
		
	hlsess->dialog = gtk_dialog_new();

	gtk_window_set_position(GTK_WINDOW(hlsess->dialog), GTK_WIN_POS_CENTER);
	gtk_window_set_modal(GTK_WINDOW(hlsess->dialog), TRUE);
	gtk_window_set_title(GTK_WINDOW(hlsess->dialog), HL_REMOVE_DIALOG_TITLE);
	
	ok_button = gtk_button_new_with_label(HL_BUTTON_OK);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (hlsess->dialog)->action_area), ok_button, TRUE, TRUE, 0);
	gtk_widget_show(ok_button);
	
	cancel_button = gtk_button_new_with_label(HL_BUTTON_CANCEL);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (hlsess->dialog)->action_area), cancel_button, TRUE, TRUE, 0);
	gtk_widget_show(cancel_button);
	
	table = gtk_table_new(1 ,2 , FALSE);
	gtk_container_set_border_width(GTK_CONTAINER(table), 10);		
	gtk_table_set_col_spacing(GTK_TABLE(table),0, 10);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (hlsess->dialog)->vbox), table, TRUE, TRUE, 0);
	gtk_widget_show(table);
	
	label = gtk_label_new(HL_LABEL_REMOVE_USER);
	gtk_table_attach_defaults(GTK_TABLE(table), label, 0, 1, 0, 1);
	gtk_widget_show(label);
	
	
	hlsess->entry = gtk_combo_new();
	gtk_entry_set_editable(GTK_ENTRY(GTK_COMBO(hlsess->entry)->entry), FALSE);
	gtk_combo_set_popdown_strings(GTK_COMBO(hlsess->entry), users);
	gtk_table_attach_defaults(GTK_TABLE(table), hlsess->entry, 1, 2, 0, 1);
	gtk_widget_show(hlsess->entry);

	gtk_signal_connect(GTK_OBJECT(ok_button), "clicked", GTK_SIGNAL_FUNC(hl_ok_remove_func), hlsess);
	gtk_signal_connect(GTK_OBJECT(cancel_button), "clicked", GTK_SIGNAL_FUNC(hl_cancel_func), hlsess);
	gtk_widget_show_all(hlsess->dialog);
}


void destroy_hl_list(gpointer data)
{
	gchar *temp = (gchar *)data;
	g_free(temp);
}

void command_hotlist_online(gtk_sess *sess, gchar *instr)
{
	gchar *seplist[2];
	gchar *username;
	gint speed;
	gint row=0;
	
	seperate_string(instr, (gchar **)seplist, 2);
	speed = atoi(seplist[1]);
	
	while((gtk_clist_get_text(GTK_CLIST(sess->hotlist.offlinelist), row, 0, &username) != 0) &&
		(strcasecmp(username, seplist[0]) != 0))
	{
		row++;
		username = NULL;
	}

	if(username != NULL) gtk_clist_remove(GTK_CLIST(sess->hotlist.offlinelist), row);
	
	row = gtk_clist_append(GTK_CLIST(sess->hotlist.onlinelist), &seplist[0]);
	if(speed < 4) gtk_clist_set_pixtext(GTK_CLIST(sess->hotlist.onlinelist), row, 0, seplist[0], 2, sess->pixmaps.pm_red, sess->pixmaps.bm_red );
	else if(speed < 7) gtk_clist_set_pixtext(GTK_CLIST(sess->hotlist.onlinelist), row, 0, seplist[0], 2, sess->pixmaps.pm_gold, sess->pixmaps.bm_gold );
	else gtk_clist_set_pixtext(GTK_CLIST(sess->hotlist.onlinelist), row, 0, seplist[0], 2, sess->pixmaps.pm_green, sess->pixmaps.bm_green );	
}

void command_hl_useradd(gtk_sess *sess, gchar *username)
{
	gtk_clist_append(GTK_CLIST(sess->hotlist.offlinelist), &username);
}

void add_user_to_hotlist(gtk_sess *sess, gchar *username)
{
	send_string(sess, username, 207);
}

void command_hotlist_results(gtk_sess *sess, gchar *instr)
{
	gchar *seplist[7];
	gchar *inlist[5];
	gchar *time;
	gchar *size;
	gchar *data;
	gint row;
	
	seperate_string(instr, (gchar **)seplist, 7);

	data = (gchar *)g_malloc(strlen(seplist[1]) + 1);
	strcpy(data, seplist[1]);

	time = make_text_time((glong)atoi(seplist[6]), sess->SHOW_DHMS);
	size = make_text_size((glong)atoi(seplist[3]));

	inlist[0] = make_file(seplist[1]);
	if(sess->SHOW_BYTE) inlist[1] = size;
	else inlist[1] = seplist[3];
	inlist[2] = seplist[4];
	inlist[3] = seplist[5];
	inlist[4] = time;
	
	row = gtk_clist_append(GTK_CLIST(sess->hotlist.clist), inlist);
	gtk_clist_set_row_data_full(GTK_CLIST(sess->hotlist.clist), row, data, destroy_hl_list);
	
	g_free(size);
	g_free(time);
}

void hl_selection_changed(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	sess->hotlist.selection = g_list_append(sess->hotlist.selection, GINT_TO_POINTER(row));
}

void hl_selection_unselected(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer user_data)
{
	gtk_sess *sess = (gtk_sess *)user_data;
	sess->hotlist.selection = g_list_remove(sess->hotlist.selection, GINT_TO_POINTER(row));
}

GtkWidget *make_hotlist_page(gtk_sess *sess)
{
	GtkWidget *listbox;
	GtkWidget *mainbox;
	GtkWidget *hpaned;
	GtkWidget *scrolled_filelist;
	GtkWidget *scrolled_onlinelist;
	GtkWidget *scrolled_offlinelist;
	gchar *ltitles[5] = {COLUMN_FILENAME,COLUMN_FILESIZE,COLUMN_BITRATE,COLUMN_FREQ, COLUMN_LENGTH};
	gchar *onlinetitle = COLUMN_ONLINE;
	gchar *offlinetitle = COLUMN_OFFLINE;

	mainbox = gtk_vbox_new(FALSE, 0);

	hpaned = gtk_hpaned_new();
	gtk_box_pack_start(GTK_BOX(mainbox), hpaned, TRUE, TRUE, 0);
	gtk_widget_show(hpaned);

	sess->hotlist.clist = gtk_clist_new_with_titles(5, ltitles);
  	gtk_clist_set_shadow_type(GTK_CLIST(sess->hotlist.clist), GTK_SHADOW_OUT);
  	gtk_clist_set_selection_mode(GTK_CLIST(sess->hotlist.clist), GTK_SELECTION_EXTENDED);
	gtk_clist_set_column_width(GTK_CLIST(sess->hotlist.clist), 0, 300);
	gtk_clist_set_column_width(GTK_CLIST(sess->hotlist.clist), 1, 50);
	gtk_clist_set_column_width(GTK_CLIST(sess->hotlist.clist), 2, 40);
	gtk_clist_set_column_width(GTK_CLIST(sess->hotlist.clist), 3, 40);
	gtk_clist_set_column_width(GTK_CLIST(sess->hotlist.clist), 4, 40);
	scrolled_filelist = gtk_scrolled_window_new (NULL, NULL);
   	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_filelist), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	gtk_paned_add2(GTK_PANED(hpaned), scrolled_filelist);
   	gtk_widget_show(scrolled_filelist);
   
   	gtk_container_add (GTK_CONTAINER (scrolled_filelist), sess->hotlist.clist);
	gtk_signal_connect(GTK_OBJECT(sess->hotlist.clist), "select_row", GTK_SIGNAL_FUNC(hl_selection_changed), sess);
	gtk_signal_connect(GTK_OBJECT(sess->hotlist.clist), "unselect_row", GTK_SIGNAL_FUNC(hl_selection_unselected), sess);
	gtk_signal_connect(GTK_OBJECT(sess->hotlist.clist), "button_press_event", GTK_SIGNAL_FUNC(hotlist_right_clicked), sess);
	gtk_signal_connect(GTK_OBJECT(sess->hotlist.clist), "click-column", GTK_SIGNAL_FUNC(hotlist_sort_column), NULL);

	gtk_widget_show(sess->hotlist.clist);
	
	listbox = gtk_vbox_new(FALSE, 0);
	gtk_paned_add1(GTK_PANED(hpaned), listbox);
	gtk_widget_show(listbox);

	sess->hotlist.onlinelist = gtk_clist_new_with_titles(1, &onlinetitle);
  	gtk_clist_set_shadow_type(GTK_CLIST(sess->hotlist.onlinelist), GTK_SHADOW_OUT);
	scrolled_onlinelist = gtk_scrolled_window_new (NULL, NULL);
   	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_onlinelist), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	gtk_box_pack_start(GTK_BOX(listbox), scrolled_onlinelist, TRUE, TRUE, 0);
   	gtk_widget_show(scrolled_onlinelist);

   	gtk_container_add (GTK_CONTAINER (scrolled_onlinelist), sess->hotlist.onlinelist);
	gtk_signal_connect(GTK_OBJECT(sess->hotlist.onlinelist), "button_press_event", GTK_SIGNAL_FUNC(ahluser_right_clicked), sess);
	gtk_signal_connect(GTK_OBJECT(sess->hotlist.onlinelist), "click-column", GTK_SIGNAL_FUNC(hluser_sort_column), NULL);
	gtk_widget_show(sess->hotlist.onlinelist);
	
	sess->hotlist.offlinelist = gtk_clist_new_with_titles(1, &offlinetitle);
  	gtk_clist_set_shadow_type(GTK_CLIST(sess->hotlist.offlinelist), GTK_SHADOW_OUT);
	scrolled_offlinelist = gtk_scrolled_window_new (NULL, NULL);
   	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_offlinelist), GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
	gtk_box_pack_start(GTK_BOX(listbox), scrolled_offlinelist, TRUE, TRUE, 0);
  	gtk_widget_show(scrolled_offlinelist);

  	gtk_container_add (GTK_CONTAINER (scrolled_offlinelist), sess->hotlist.offlinelist);
	gtk_signal_connect(GTK_OBJECT(sess->hotlist.offlinelist), "button_press_event", GTK_SIGNAL_FUNC(uhluser_right_clicked), sess);	
	gtk_signal_connect(GTK_OBJECT(sess->hotlist.offlinelist), "click-column", GTK_SIGNAL_FUNC(hluser_sort_column), NULL);
	gtk_widget_show(sess->hotlist.offlinelist);
	
	gtk_paned_set_position(GTK_PANED(hpaned), 150);

	return mainbox;
}
