/* GTK Napster-0.301
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#include <string.h>
#include <unistd.h>

#include "common.h"
#include "nmisc.h"

void play_file(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *) data;
	gtk_dl_sess *dlsess;
	gchar *filename;

	dlsess = gtk_clist_get_row_data(GTK_CLIST(sess->transfer_list), GPOINTER_TO_INT(g_list_nth_data(sess->transfer_sel, 0)));
	filename = make_file(dlsess->filename);
	
	open_file(sess, filename);
}

void open_file(gtk_sess *sess, gchar *filename)
{
	gchar *argv[4];
	gint pid, i;
	gchar *filepath;
	gchar *command;

	filepath = (gchar *)g_malloc(strlen((gchar *)sess->directory) + strlen(filename)*2 + 4);
	strcpy(filepath, "\'");
	strcat(filepath, (gchar *)sess->directory);
	if(sess->directory[strlen(sess->directory)-1] != '/') strcat(filepath, "/");
	for(i = 0; i<strlen(filename); i++)
	{
		if(filename[i] != '\'')
			strncat(filepath, &filename[i], 1);
		else
			strcat(filepath, "\'\\\'\'");
	}
	strcat(filepath, "\'");
		
	command = g_malloc(strlen(filepath) + strlen((gchar *)sess->exec_player) + 1);
	sprintf(command,(gchar *)sess->exec_player, filepath);

	g_free(filepath);

	pid = fork();
	if(pid == 0)
	{
		argv[0] = "sh";
		argv[1] = "-c";
		argv[2] = command;
		argv[3] = 0;
		execve("/bin/sh", argv, environ);
		exit(127);
	}
	else
	{		
		g_free(command);
	}
}

gchar *make_text_size(glong size)
{
	gchar msg[20];
 	if(size < 1024)
 	{
 		sprintf((gchar*)msg, "%d byte", (gint)size);
 		return g_strdup((gchar*)msg);
 	}
 	if(size < 1048576)
	{
		sprintf((gchar*)msg, "%d KB", (gint)size/1024);
		return g_strdup((gchar*)msg);
	}
	else
	{
		sprintf((gchar*)msg, "%.2f MB", (gdouble)size/1048576);
		return g_strdup((gchar*)msg);
	}		
}

gchar *make_text_time(glong intime, gboolean STYLE)
{
	gchar msg[20];
	gint days;
	gint hours;
	gint minutes;
	gint seconds;
	
	msg[0] = '\0';
	days = intime/86400;
	intime -= days*86400;
	hours = intime/3600;
	intime -= hours*3600;
	minutes = intime/60;
	intime -= minutes*60;
	seconds = intime;
	
	if(days != 0)
	{
		if(STYLE)sprintf((gchar*)msg, "%dd ", days);
		else sprintf((gchar*)msg, "%d:", days);
	}
		
	if(hours != 0 || days != 0)
	{
		if(STYLE)sprintf((gchar*)msg+strlen(msg), "%.2dh ", hours);
		else sprintf((gchar*)msg+strlen(msg), "%.2d:", hours);
	}
		
	if(STYLE)
	{
		sprintf((gchar*)msg+strlen(msg), "%.2dm ", minutes);
		sprintf((gchar*)msg+strlen(msg), "%.2ds", seconds);
	}
	else
	{
		sprintf((gchar*)msg+strlen(msg), "%.2d:", minutes);
		sprintf((gchar*)msg+strlen(msg), "%.2d", seconds);
	}
	
	return g_strdup((gchar*)msg);
}
