/* GTK Napster-0.301
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */
#include <string.h>
#include <stdlib.h>

#include "common.h"
#include "nreadcom.h"

gint find_chat_nr(gtk_sess *sess, GtkWidget *widget)
{
	gint i;
	
	for(i=0; i<sess->nr_chatwins; i++)
	{
		if(sess->chatwins[i].cmsg == widget) return i;
	}
	return -1;
}

void get_file_from(gtk_sess *sess, gboolean searchWindow, gint selrow)
{
	gchar *user;
	gchar *bitrate;
	gchar *freq;
	gchar *filename;
	gchar *real_filename;
	gchar *command;
	gchar *listitem[6];
	GdkPixmap *pixm;
	GdkBitmap *bitm;
	gint spacing;
	gint row;
	gtk_dl_sess *dlsess;

	dlsess = (gtk_dl_sess *)g_malloc(sizeof(gtk_dl_sess));
	memset(dlsess, 0, sizeof(gtk_dl_sess));
	dlsess->sess = sess;

	memset(listitem, 0, sizeof(listitem));

	if(searchWindow)
	{
		filename = (gchar *)gtk_clist_get_row_data(GTK_CLIST(sess->clist), selrow);
		if(filename == NULL) return;
		gtk_clist_get_text(GTK_CLIST(sess->clist), selrow, 5, &user);
		gtk_clist_get_text(GTK_CLIST(sess->clist), selrow, 2, &bitrate);
		gtk_clist_get_text(GTK_CLIST(sess->clist), selrow, 3, &freq);
		gtk_clist_get_pixtext(GTK_CLIST(sess->clist), selrow, 0, &real_filename, (guint8 *)&spacing, &pixm, &bitm);
	}
	else
	{
		filename = (gchar *)gtk_clist_get_row_data(GTK_CLIST(sess->hotlist.clist), selrow);
		if(filename == NULL) return;
		gtk_clist_get_text(GTK_CLIST(sess->hotlist.clist), selrow, 0, &real_filename);
		gtk_clist_get_text(GTK_CLIST(sess->hotlist.clist), selrow, 2, &bitrate);
		gtk_clist_get_text(GTK_CLIST(sess->hotlist.clist), selrow, 3, &freq);
		user = (gchar *)sess->hotlist.user;
		spacing = sess->hotlist.spacing;
		pixm = sess->hotlist.pixm;
		bitm = sess->hotlist.bitm;
	}
	
	dlsess->bitrate = atol(bitrate);
	dlsess->freq = atoi(freq);
	
	listitem[3] = user;
	listitem[5] = TRANSFER_STATUS_WAIT;

	row = gtk_clist_append(GTK_CLIST(sess->transfer_list), listitem);
	gtk_clist_set_pixtext(GTK_CLIST(sess->transfer_list), row, 0, real_filename, spacing, pixm, bitm);
	gtk_clist_set_row_data_full(GTK_CLIST(sess->transfer_list), row, dlsess, destroy_transfer_item);
	
	dlsess->filename = (gchar *)g_malloc(strlen(filename)+1);
	strcpy(dlsess->filename, filename);
	
	if(!must_be_queued(sess))
	{
		command = (gchar *)g_malloc(strlen(filename) + strlen(user) + 5);
		sprintf(command, "%s \"%s\"", user, filename);

		if(!send_string(sess, command, 203))
		{
			gtk_clist_set_text(GTK_CLIST(sess->transfer_list), row, 5, TRANSFER_STATUS_ERROR);
			gtk_statusbar_push(GTK_STATUSBAR(sess->statusbar), 1, STATUSBAR_GET_INFO);
		}
		g_free(command);
		dlsess->CONNECTING = TRUE;
	}	
	else
	{
		gtk_clist_set_text(GTK_CLIST(sess->transfer_list), row, 5, TRANSFER_STATUS_QUEUED);
		sess->queue = g_list_append(sess->queue, (gpointer)dlsess);
	}

	if(sess->SWITCH_TRANSFER) change_to_transfer(NULL, (gpointer)sess);
}

void destroy_transfer_item(gpointer data)
{
	gtk_dl_sess *dlsess = (gtk_dl_sess *)data;
	cancel_download_sess(dlsess);
	if(dlsess->CONNECTING) 
	{
		dlsess->CLEAR = TRUE;
		return;
	}
	g_free(dlsess->filename);
	g_free(dlsess);
}

void command_do_search(GtkWidget *w, gpointer data)
{
	gtk_sess *sess = (gtk_sess *)data;
	gchar *inlist[7];
	gchar *song;
	gchar *max_hits;
	gchar *inspeed;
	gchar *infreq;
	gchar *inbitrate;
	gint speed;
	gchar *bitrate;
	gchar *command;
	gchar *freq;
	
	memset(inlist, 0, sizeof(inlist));
	inlist[0] = CLIST_SEARCH_SEARCHING;
	
	song = gtk_entry_get_text(GTK_ENTRY(sess->search.search_for_entry));
	max_hits = gtk_entry_get_text(GTK_ENTRY(sess->search.max_results_entry));
	inspeed = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sess->search.linespeed_combo)->entry));
	infreq = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sess->search.freq_combo)->entry));
	inbitrate = gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sess->search.bitrate_combo)->entry));
	
	command = (gchar *)g_malloc(120 + strlen(song) + strlen(max_hits) + strlen(inspeed) + strlen(infreq) + strlen(inbitrate));
	

	if((strlen(song) != 0) && (strlen(max_hits) != 0))
	{
		sprintf(command, "FILENAME CONTAINS \"%s\" MAX_RESULTS %s", song, max_hits);
		
		if(strcmp(inspeed, "") != 0)
		{
			speed = get_speed_nr(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sess->search.linespeed_combo)->entry)));
			sprintf(&command[strlen(command)], " LINESPEED \"%s\" %d", gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sess->search.linespeed_crit)->entry)), speed);
		}
		
		if(strcmp(infreq, "") != 0)
		{
			freq = strchr(infreq, ' ');
			if(freq != NULL) freq[0] = '\0';
			sprintf(&command[strlen(command)], " FREQ \"%s\" \"%s\"", gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sess->search.freq_crit)->entry)), (gchar *)infreq);
		}
		
		if(strcmp(inbitrate, "") != 0)
		{
			bitrate = strchr(inbitrate, ' ');
			if(bitrate != NULL) bitrate[0] = '\0';
			sprintf(&command[strlen(command)], " BITRATE \"%s\" \"%s\"", gtk_entry_get_text(GTK_ENTRY(GTK_COMBO(sess->search.bitrate_crit)->entry)), (gchar *)inbitrate);
		}

		if(g_list_length(sess->current_sel) > 0) g_list_free(sess->current_sel);
		sess->current_sel = NULL;
		
		gtk_clist_clear(GTK_CLIST(sess->clist));
		gtk_clist_append(GTK_CLIST(sess->clist), inlist);
		if(!send_string(sess, command, 200))
		{
			gtk_statusbar_push(GTK_STATUSBAR(sess->statusbar), 1, STATUSBAR_SEARCH_INFO);
		}
	}
	g_free(command);
}

void command_join(gtk_sess *sess, gchar *command, gint nr_chat)
{
   gchar *seplist[2];
   
   if(seperate_string(command, (gchar **)seplist, 2))
	{
		if(!send_string(sess, seplist[1], 400))
		{
			gtk_statusbar_push(GTK_STATUSBAR(sess->statusbar), 1, STATUSBAR_JOIN_INFO);
		}
	}
	else
	{
		string_out(sess->chatwins[nr_chat].ctext, COMMAND_JOIN_HELP, 0, 0xffff, 0xffff);
	}
}

void command_tell(gtk_sess *sess, gchar *command, gint nr_chat)
{
	gchar *seplist[3];
	gchar *msg;

	if(seperate_string(command, (gchar **)seplist, 3))
	{
		msg = (gchar *)g_malloc(strlen(seplist[1]) + strlen(seplist[2]) + 15);
		sprintf(msg, "%s %s", seplist[1], seplist[2]);
		if(!send_string(sess, msg, 205))
		{
			gtk_statusbar_push(GTK_STATUSBAR(sess->statusbar), 1, STATUSBAR_TELL_INFO);
			g_free(msg);
			return;
		}
		sprintf(msg, MSG_YOU_TELL, seplist[1], seplist[2]);
		string_out(sess->chatwins[nr_chat].ctext, msg, 0, 0, 0xffff);
		g_free(msg);
	}
	else
	{
		string_out(sess->chatwins[nr_chat].ctext, COMMAND_TELL_HELP, 0, 0xffff, 0xffff);
	}
}

void command_ping(gtk_sess *sess, gchar *command, gint nr_chat)
{
	gchar *seplist[2];

	if(seperate_string(command, (gchar **)seplist, 2))
	{
		if(!send_string(sess, seplist[1], 751))
		{
			gtk_statusbar_push(GTK_STATUSBAR(sess->statusbar), 1, STATUSBAR_JOIN_INFO);
		}
	}
	else
	{
		string_out(sess->chatwins[nr_chat].ctext, COMMAND_PING_HELP, 0, 0xffff, 0xffff);
	}
}

void command_whois(gtk_sess *sess, gchar *command, gint nr_chat)
{
	gchar *seplist[2];

	if(seperate_string(command, (gchar **)seplist, 2))
	{
		if(!send_string(sess, seplist[1], 603))
		{
			gtk_statusbar_push(GTK_STATUSBAR(sess->statusbar), 1, STATUSBAR_WHOIS_INFO);
		}
	}
	else
	{
		string_out(sess->chatwins[nr_chat].ctext, COMMAND_WHOIS_HELP, 0, 0xffff, 0xffff);
	}
}

void command_msg(gtk_sess *sess, gchar *command, gint nr_chat)
{
	gchar *outmsg;
	
	outmsg = (gchar *)g_malloc(strlen(command) + strlen(sess->chatwins[nr_chat].name) + 2);
	sprintf(outmsg, "%s %s", sess->chatwins[nr_chat].name, command);

	if(!send_string(sess, outmsg, 402))
	{
		gtk_statusbar_push(GTK_STATUSBAR(sess->statusbar), 1, STATUSBAR_TELL_INFO);
	}
	
	g_free(outmsg);
}

void command_leave_channel(gtk_sess *sess, gint nr_chat)
{
	if(nr_chat != 0)
	{
		if(!send_string(sess, (gchar *)sess->chatwins[nr_chat].name, 401))
		{
			gtk_statusbar_push(GTK_STATUSBAR(sess->statusbar), 1, STATUSBAR_LEAVE_INFO);
		}
		gtk_notebook_remove_page(GTK_NOTEBOOK (sess->notebook), gtk_notebook_get_current_page(GTK_NOTEBOOK (sess->notebook)));
		memcpy(&sess->chatwins[nr_chat], &sess->chatwins[sess->nr_chatwins-1], sizeof(gtk_chat_window));
		sess->chatwins = (gtk_chat_window *) g_realloc(sess->chatwins, (sizeof(gtk_chat_window)*(sess->nr_chatwins-1)));
		sess->nr_chatwins--;
	}
	else
	{
		string_out(sess->chatwins[nr_chat].ctext, MSG_CANNOT_LEAVE, 0, 0xffff, 0xffff);
	}
}

void read_command(GtkWidget *widget, gpointer data)
{
	gtk_sess *sess = (gtk_sess *) data;
  	gint nr_chat;
	gchar *command;
		
	command = gtk_entry_get_text(GTK_ENTRY(widget));
	
	nr_chat = find_chat_nr(sess, widget);
		
	if(nr_chat != -1)
	{
		if(command[0] == '/')
		{
			if(strstr(command, COMMAND_JOIN) == command) command_join(sess, command, nr_chat);
			else if(strstr(command, COMMAND_J) == command) command_join(sess, command, nr_chat);
			else if(strstr(command, COMMAND_TELL) == command) command_tell(sess, command, nr_chat);
			else if(strstr(command, COMMAND_MSG) == command) command_tell(sess, command, nr_chat);
			else if(strstr(command, COMMAND_PING) == command) command_ping(sess, command, nr_chat);
			else if(strstr(command, COMMAND_WHOIS) == command) command_whois(sess, command, nr_chat);
			else if(strstr(command, COMMAND_LEAVE) == command) command_leave_channel(sess, nr_chat);
			else string_out(sess->chatwins[nr_chat].ctext, COMMAND_UNKNOWN, 0, 0xffff, 0xffff);
		}
		else
		{
			if(strcasecmp(sess->chatwins[nr_chat].name, PRIVATE_CHAT_WINDOW) == 0)
			{
				string_out(sess->chatwins[nr_chat].ctext, MSG_CANNOT_SEND, 0, 0xffff, 0xffff);
			}
			else
			{
				command_msg(sess, command, nr_chat);
			}
		}
	}
	else
	{
		g_warning(WARNING_READ_COMMAND);
	}
	gtk_entry_set_text(GTK_ENTRY(widget), "");
}