/* GTK Napster-0.301
 * Copyright (C) 2000 Unified (xilliator@hotmail.com).
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA
 */

#ifndef _ULSESS_H_
#define _ULSESS_H_

#include <dirent.h>

#define UPLOAD_ERROR_UPLOAD 					"Error: Failed to create upload socket."
#define UPLOAD_ERROR_SEND		 				"Error: Failed to send SEND."
#define UPLOAD_ERROR_FILENAME 					"Error: Failed to send username and filename to server."
#define UPLOAD_ERROR_INVALID_REQUEST		 	"Error: Received an INVALID REQUEST from host."
#define UPLOAD_ERROR_NOT_SHARED		 			"Error: The file is NOT SHARED."
#define UPLOAD_ERROR_NOT_FOUND		 			"Error: The file is NOT FOUND."
#define UPLOAD_ERROR_FILE		 				"Error: Opening file for reading."

#define UPLOAD_STATUS_CONNECTING	 			"Connecting..."
#define UPLOAD_STATUS_SEND	 					"Send Info..."
#define UPLOAD_STATUS_OK	 					"Get Info..."
#define UPLOAD_STATUS_UPLOAD		 			"Uploading..."
#define UPLOAD_STATUS_ERROR			 			"Error!"
#define UPLOAD_STATUS_CANCEL			 		"Canceled!"
#define UPLOAD_STATUS_TIMEOUT		 			"Timeout!"
#define UPLOAD_STATUS_WAIT						"Waiting..."
#define UPLOAD_STATUS_FINISH	 				"Finished!"
#define WARNING_FILE_NOT_FOUND 					"File %s not found!"


static gint bitrate_mpeg1[3][14] = {
{32, 40, 48,  56,  64,  80,  96, 112, 128, 160, 192, 224, 256, 320},
{32, 48, 56,  64,  80,  96, 112, 128, 160, 192, 224, 256, 320, 384},
{32, 64, 96, 128, 160, 192, 224, 256, 288, 320, 352, 384, 416, 448}};

static gint bitrate_mpeg2[3][14] = {
{8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160},
{8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160},
{32, 48, 56, 64, 80, 96, 112, 128, 144, 160, 176, 192, 224, 256}};
																				
static gint freq_table[2][3] = {
{22050, 24000, 16000}, 
{44100, 48000, 32000}};

typedef struct filedlg_parm
{
	gtk_sess *sess;
	GtkWidget *file_selector;
	GList *selected_files;
	gchar *path;
} filedlg_parm;

gint verfy_file_name(const struct dirent *file);
guint8 get_layer(guint8 inbyte);
gint get_bitrate(gboolean version, guint8 inbyte, guint8 layer);
gint get_freq(gboolean version, guint8 inbyte);
gboolean get_version(guint8 inbyte);
void file_to_write(gpointer data, gint source, GdkInputCondition condition);
glong is_file_in_library(gtk_sess *sess, gchar *filename);
void cancel_ul_sess(gtk_ul_sess *ulsess);
void destroy_ul_item(gpointer data);
void firewall_connection(gtk_sess *sess, gchar *instr);
void incomming_connection(gpointer data, gint source, GdkInputCondition condition);
void ul_incomming(gtk_sess *sess, gint socketfd, time_t start_time);
void make_socket_listener(gtk_sess *sess);
gchar *make_md5(FILE *stream, glong size);
void destroy_library_item(gpointer data);
void make_share_list(gtk_sess* sess);
void file_selection_changed(GtkWidget *widget, gint row, gint column, GdkEventButton *event, gpointer data);
void file_selection_unselected(GtkCList *clist, gint row, gint column, GdkEventButton *event, gpointer user_data);
gchar *make_back_compatibel(gchar *filename);
gchar *make_compatibel(gchar *filename);

#endif